/*
 * this is an simple and stupid shell example
 * for JariOS
 */

#include <stdbool.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <ipc/rpc.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <wchar.h>
#include <errno.h>
#include <devio/devio.h>
#include <ctype.h>
#include <pthread.h>
#include <sys/scheduler.h>
#include <sys/proc.h>
#include <sys/thread.h>
#include <sys/syscall.h>
#include <alloc/imcache.h>
#include <sys/ptd.h>
#include <dircons.h>
#include <datastructs.h>

#include "builtin.h"

#define TBUFLEN 32768

#define TERM_SLOT 6
#define BUFF_SLOT 5

void *udav(void *arg);

status_t open_term(ulong_t termno)
{
  char tmp[16];
  char *buf;
  int termfd;

  buf = malloc(TBUFLEN);
  if(!buf) {
    console_printf("Cannot allocate memory for printing buffer.\n");
  }

  sprintf(tmp, "/dev/ptm%lu", termno);
  termfd = open(tmp, O_RDWR);

  if(termfd < 0) return -1;
  
  (PTD()->custom_slots[TERM_SLOT]) = (ulong_t)termfd;
  (PTD()->custom_slots[BUFF_SLOT]) = (ulong_t)buf;
  
  return 0;
}

int ascii_puts(const char *msg)
{
  int r=0;
  int len=strlen(msg);
  int fd = (int)PTD()->custom_slots[TERM_SLOT];

  r = write(fd, msg, len*sizeof(char));
  
  return r;
}

void ascii_printf(const char *fmt,... )
{
  char *buf = (char *)(PTD()->custom_slots[BUFF_SLOT]);
  va_list ap;
  va_start(ap, fmt);
  vsnprintf(buf, TBUFLEN, fmt, ap);
  va_end(ap);
  ascii_puts(buf);
  return;                                                                                   
}

int get_string(char *buf, int size)
{
  int r=0;
  int fd = (int)PTD()->custom_slots[TERM_SLOT];
  
  r = read(fd, buf, size-1);
  if(r >= 0) buf[r] = 0;
  
  return r;
}

void *ptthread(void *arg) {
  ulong_t tn = (ulong_t) arg;
  char *buf=malloc(512);
  char *__pwd=malloc(512);

  if(open_term(tn) != 0) abort();

  ascii_printf("Welcome to Jari OS demo and testing shell. Have a look at <Alt-F10> terminal.\n");

  memset(__pwd,'\0',512);
  getcwd(__pwd,512);

  while(true) {
    ascii_printf("\e[34msupervisor@\e[31m%s:>\e[0m ",__pwd);
    get_string(buf, 1024);
    builtin(buf);
    getcwd(__pwd,512);
  }
}

#define NUM_TERMS 5

int main(int argc,char **argv)
{
  ulong_t i;
  int r;
  pthread_t thrs[NUM_TERMS+1];

#ifndef CONFIG_CTSH_GRUB
  start_service();
#endif

  open_console();

  memset(thrs, 0, sizeof(thrs));

  for(i = 0; i < NUM_TERMS; i++) {
    r = pthread_create(&thrs[i], NULL, ptthread, (void *)i);
    if(r != 0) {
      console_printf("Failed to create per term shell threads.\n");
      abort();
    }
  }

  r = pthread_create(&thrs[NUM_TERMS], NULL, udav, NULL);

  while(true) {
    sleep(100);
  }
}
