# Makefile.mk
# microkernel drivers
# Originally written by MadTirra <madtirra@jarios.org>
# (c) Jari OS core development team 2005-2008
#

-include ../.config

# Console drivers
ifeq ($(CONFIG_VGACONS),y)
-include devices/consoles/vgacons/Makefile.mk
endif

ifeq ($(CONFIG_VESACONS),y)
-include devices/consoles/vesacons/Makefile.mk
endif

ifeq ($(CONFIG_VESACONSV2),y)
-include devices/consoles/vesaconsv2/Makefile.mk
endif

# Input drivers
ifeq ($(CONFIG_PCKEYB),y)
-include devices/input/pckeyb/Makefile.mk
endif

# Controllers

# RTC driver
ifeq ($(CONFIG_RTC),y)
-include devices/amd64/rtclock/Makefile.mk
endif

#IOAPIC
ifeq ($(CONFIG_IOAPIC),y)
-include devices/ioapic/Makefile.mk
endif

# Buses

#PCID
ifeq ($(CONFIG_PCID),y)
-include devices/bus/pci/Makefile.mk
endif

#Serial port
ifeq ($(CONFIG_SERIAL),y)
-include devices/serial/Makefile.mk
endif

# pseudo devices

# ram_disk driver
ifeq ($(CONFIG_RAMDISK),y)
-include devices/pseudo/ram_disk/Makefile.mk
endif

#/dev/zero and /dev/null driver
ifeq ($(CONFIG_ZERO),y)
-include devices/pseudo/zero/Makefile.mk
endif

ifeq ($(CONFIG_INTEL_E1000),y)
-include devices/net/e1000/Makefile.mk
endif

ifeq ($(CONFIG_RTL_8139),y)
-include devices/net/rtl8139/Makefile.mk
endif

ifeq ($(CONFIG_ATA),y)
-include devices/block/ata/Makefile.mk
endif
