/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 Paul Graphov <graphov@jarios.org> 
 *
 * Real time clock driver
 *
 */

#ifndef __RTCLOCK_H__
#define __RTCLOCK_H__

// RTC io ports
#define RTC_ADDRESS 0x70
#define RTC_DATA 0x71

// RTC registers

// Current time and date
#define RTC_SECONDS 0x0
#define RTC_MINUTES 0x2
#define RTC_HOURS 0x4
#define RTC_DAY_OF_WEEK 0x6
#define RTC_DAY_OF_MONTH 0x7
#define RTC_MONTH 0x8
#define RTC_YEAR 0x9

//Alarm control
#define RTC_ALARM_SECONDS 0x1
#define RTC_ALARM_MINUTES 0x3
#define RTC_ALARM_HOURS 0x5

#endif
