# Makefile.mk
# microkernel ata command layer driver
# Originally written by Dmitry Gromada <gromada@jarios.org
#
# It's temporary linked as static library, then will be changed to dll
# when dynamic elf will be available

ATA_OBJS = devices/block/ata/ata-blk.o devices/block/ata/pata.o \
           devices/block/ata/ata-rq.o devices/block/ata/ata-intr.o \
           devices/block/ata/ide-disk.o

ifeq ($(CONFIG_ATA_STATLINK),y)
ATA_OBJS += devices/block/ata/pci/ide_piix.o devices/block/ata/pci/ide_amd74.o \
            devices/block/ata/pci/generic.o devices/block/ata/pci/generic-ide.o 
else
ATA_LIBS = libblkdev.a libata.a libmisc.a $(CONFIG_SYSLIBDIR)/lib/libpci.a \
           $(CONFIG_SYSLIBDIR)/lib/libsys.a $(CONFIG_SYSLIBDIR)/lib/libc.a \
           $(CONFIG_SYSLIBDIR)/lib/libpthread.a
endif

CLEAN_OBJS += $(ATA_OBJS)

LIBS_STATIC += atadrv.a
#DEVS_DUMP += atadrv.dump

atadrv.a: $(ATA_OBJS)
	$(Q)$(ECHO) "[AR] atadrv.a"
	$(Q)$(AR) rc atadrv.a $(ATA_OBJS) $(ATA_LIBS) libmisc.a
