/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Dmitry Gromada <gromada@jarios.org>
 *
 * ATA device drivers related stuffs
 */

#ifndef __ATA_DRV_H__
#define __ATA_DRV_H__

#include <stdbool.h>
#include <sys/types.h>
#include <ata/ata.h>
#include <sys/ievent.h>

extern ata_driver_t idedisk_driver;
extern ata_driver_t idecd_driver;

int init_ata_interrupts(ata_host_t *host, irq_handler_t handler);
void release_ata_interrupts(ata_host_t *host);

int pata_prepare_cmd(ata_device_t *dev, ata_cmd_t *cmd);
void pata_timeout_handler(ata_device_t *dev);
void pata_irq_handler(ata_device_t *dev, port_status_t port_stat);
int pata_ready_cmd_tag(ata_device_t *dev);

int ata_process_rq(ata_device_t *dev, blk_request_t *rq);
int atapi_process_rq(ata_device_t *dev, blk_request_t *rq);

bool idedisk_match(ata_host_t *host, ata_device_t *dev);
int idedisk_init(ata_device_t *dev);
bool idedisk_cmd_nestable(ata_device_t *dev, ata_cmd_t *cmd);
void idedisk_prep_cmd_retry(ata_cmd_t *cmd);
void idedisk_error_handler(ata_device_t *dev, int err_type, uint32_t status);
int idedisk_post_issue_cmd(ata_device_t *dev, ata_cmd_t *cmd);

bool idecd_match(ata_host_t *host, ata_device_t *dev);
int idecd_init(ata_device_t *dev);
bool idecd_cmd_nestable(ata_device_t *dev, ata_cmd_t *cmd);
void idecd_rw_data(ata_cmd_t *cmd);
void idecd_error_handler(ata_device_t *dev, int err_type, uint32_t status);
void idecd_prep_cmd_retry(ata_cmd_t *cmd);

#endif /* __ATA_DRV_H__ */
