/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Dmitry Gromada <gromada@jarios.org>
 *
 * Common part of parallel ata drivers
 */

#include <datalib/list.h>
#include <ata/libata.h>
#include "drv.h"

int pata_restart_cmd(ata_device_t *dev, ata_cmd_t *cmd)
{
  return 0;
}

int pata_prepare_cmd(ata_device_t *dev, ata_cmd_t *cmd)
{
  return 0;
}

void pata_timeout_handler(ata_device_t *dev)
{

}

int pata_ready_cmd_tag(ata_device_t *dev)
{
  ata_taskfile_t tf;
  ata_srv_info_t srv;
  int r;

  tf.flags = (dev->run_cmd->tf.flags & ~TASKFILE_REGS_MASK) | TASKFILE_SECT_COUNT;
  if (ata_read_taskfile(dev, &tf)) {
    dev->drv->error_handler(dev, ATA_ERROR_HOST, 0);
    r = -1;
  } else {
    srv.val = tf.nsect;
    r = srv.tag;
  }

  return r;
}
