/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 Paul Graphov <graphov@jarios.org> 
 *
 * PCI bus driver
 *
 */

#ifndef __PCI_H__
#define __PCI_H__

enum {
  PCI_ERR_WRONG_BAR = 1,
  PCI_ERR_BAR_READ,
  PCI_ERR_UNKNOWN_HEADER,
};

enum {
  _PCI_READ,
  _PCI_WRITE,
};


typedef struct __pci_dev_descr_t {
  pci_dev_t device;
} pci_dev_descr_t;


typedef struct __pci_bus_dev_t
{
  pci_dev_descr_t *functions[8];
} pci_bus_dev_t;

typedef struct __pci_bus_t
{
  pci_bus_dev_t *devices[32];
} pci_bus_t;

#endif
