# Makefile.mk
# microkernel VESA graphical console service,
# 
# Originally written by MadTirra <madtirra@jarios.org>
# (c) Jari OS core development team 2005-2008,2009
#

VESACONS_OBJS = devices/consoles/vesacons/console.o devices/consoles/vesacons/hwops.o devices/consoles/vesacons/fb_primitives.o \
	devices/consoles/vesacons/default_font.o devices/consoles/vesacons/debug.o \
	devices/consoles/vesacons/fbcon.o devices/consoles/vesacons/pcf.o\
	devices/consoles/vesacons/pcfio.o  

DEFAULT_FONT = devices/consoles/vesacons/font/font.pcf

CLEAN_OBJS += $(VESACONS_OBJS)

DEVS_STATIC += vesacons.d.static
DEVS_DUMP += vesacons.dump
DEVS_SHARED += vesacons.d
INSTALL_CONFIGS += install_font

install_font:
	$(Q)$(ECHO) "[INS] Installing default vesacons font ..." 
	$(Q)mkdir -p $(CONFIG_INITFS_PATH)/etc/vesacons
	$(Q)cp $(DEFAULT_FONT) $(CONFIG_INITFS_PATH)/etc/vesacons/

vesacons.d.static: $(VESACONS_OBJS) libchardev.a
	$(Q)$(ECHO) "[LD] $@"
	$(Q)$(LD) $(LDFLAGS) -static $(VESACONS_OBJS) libchardev.a libmisc.a -lint10 -lvm86 $(LIBS) -o $@

vesacons.d: $(VESACONS_OBJS) libchardev.a
	$(Q)$(ECHO) "[LD] $@"
	$(Q)$(LD) $(LDFLAGS) $(VESACONS_OBJS) libchardev.a libmisc.a -lint10 -lvm86 $(LIBS) -o $@
