/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008-2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008,2009 MadTirra <madtirra@jarios.org>
 *
 * vesacons.d: Generic VESA graphical console
 * debug.h: DEBUG ONLY 
 *
 */

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "default_font.h"
#include "debug.h"

int _cdx=0;
int _cdy=0;

static void vesa_put_px16(uint16_t *area,int x,int y,uint16_t color)
{
  area[y*800+x]=color;

  return;
}

static void vesa_put_glyph16(uint16_t *area,int sx,int sy,int gly)
{
  int y,x,glyline;

  for(y=0;y<16;y++) {
    glyline=fnt8x16_table0[gly*16+y];
    for(x=0;x<8;x++) {
      if(glyline & (1 << (7 - x)))
	vesa_put_px16(area,sx+x,sy+y,0xaaaa);
    }
  }

  return;
}

static void vesa_putch16(uint16_t *area,char s)
{
  switch(s) {
  case '\n':
    _cdx=0;
    _cdy++;
    break;
  default:
    vesa_put_glyph16(area,_cdx*8,_cdy*16,(int)s);
    _cdx++;
    break;
  }

  if(_cdx>99) {
    _cdx=0;
    _cdy++;
  }
  if(_cdy>36) {
    /* need to scroll */
    _cdy--; /* move this */
    memcpy((void *)area,(void *)((uint16_t*)area+800*16),(800*600*2)-(800*16*2));
    memset((void *)(area+800*582),0,800*16*2);
  }

  return;
}

void vesa_puts16(uint16_t *area,char *s)
{
  int len=strlen(s);
  int i;

  for(i=0;i<len;i++) 
    vesa_putch16(area,s[i]);
  
  return;
}
