/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008-2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008,2009 MadTirra <madtirra@jarios.org>
 *
 * vesacons.d: Generic VESA graphical console
 * fbcon.h: framebuffer console high-level operations
 *
 */

#ifndef __FBCON_H__
#define __FBCON_H__

#include <sys/types.h>
#include <stdbool.h>

extern char *logo_data;

int fbcon_bpptype(int bpp,uint8_t red_off,uint8_t green_off,uint8_t blue_off,
		  uint8_t red_size,uint8_t green_size,uint8_t blue_size);
int fbcon_init(void *area,int xres,int yres,int bpp,int bpptype);
void fbcon_printxy(cschar_t *buf,size_t len,int x,int y);
void fbcon_print(cschar_t *msg,size_t len);
void fbcon_puts(char *msg);
void fbcon_scroll(int lines);
int fbcon_width(void);
int fbcon_height(void);
void fbcon_scrolldisable(void);
void fbcon_scrollenable(void);
void fbcon_scroll_area(int startline, int stopline, int lines);
void fbcon_setcursor(int x, int y);
void fbcon_setcursorvisibility(int to_show);
void fbcon_clear_rect(int x1, int y1, int x2, int y2, uint8_t col);
void fbcon_clear_all(void);

#endif
