# Makefile.mk
# microkernel VESA graphical console service v2,
# 
# Originally written by Paul Graphov <graphov@jarios.org>
# (c) Jari OS core development team 2005-2008,2009
#

VESACONS2_OBJS = devices/consoles/vesaconsv2/console.o\
	devices/consoles/vesaconsv2/graphics_console.o\
	devices/consoles/vesaconsv2/pcf_font.o\
	devices/consoles/vesaconsv2/pcfio.o\
	devices/consoles/vesaconsv2/builtin_font.o\
	devices/consoles/vesaconsv2/palette.o\
	devices/consoles/vesaconsv2/main.o\
	devices/consoles/vesaconsv2/vesaviewport.o\
	devices/consoles/vesaconsv2/background.o

CLEAN_OBJS += $(VESACONS2_OBJS)

DEVS_STATIC += vesaconsv2.d.static
DEVS_DUMP += vesaconsv2.dump
DEVS_SHARED += vesaconsv2.d

vesaconsv2.d.static: $(VESACONS2_OBJS) libchardev.a
	$(Q)$(ECHO) "[LD] $@"
	$(Q)$(LD) $(LDFLAGS) -static $(VESACONS2_OBJS) libchardev.a libmisc.a -lint10 -lvm86 -lpng -lz $(LIBS) -o $@

vesaconsv2.d: $(VESACONS2_OBJS) libchardev.a
	$(Q)$(ECHO) "[LD] $@"
	$(Q)$(LD) $(LDFLAGS) $(VESACONS2_OBJS) libchardev.a libmisc.a -lint10 -lvm86 -lpng -lz $(LIBS) -o $@
