/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 MadTirra <madtirra@jarios.org>
 *
 * vgacons.d: Generic VGA console driver
 * hwops.h: hardware ops
 *
 */

#ifndef __HWOPS_H__
#define __HWOPS_H__

#include <sys/console.h>

union __vga_catr {
  uint16_t val;
  struct {
    uint16_t s : 8;
    uint16_t bg : 4; 
    uint16_t fg : 4; 
  };
} __attribute__ ((packed));

void vga_init(void *buf);

void vga_print(const char *msg);

void vga_printpos(char *msg,int x,int y);

void uni_print(cschar_t *buf,size_t len);

void uni_printxy(cschar_t *buf,size_t len,int x,int y);

void vga_cursor(const bool action);
void vga_setcursor(int x, int y);

/* capatibilies */
size_t uni_width(void);
size_t uni_height(void);
/* scrolling */
void uni_scrollup(int lineno);
void uni_scrolldown(int lineno);
int uni_scroll_area(int startline, int stopline, int lineno);
void uni_scrollenable(void);
void uni_scrolldisable(void);
/* screen */
void uni_clear(void);
void uni_clear_rect(int x1, int y1, int x2, int y2, uint8_t col);

#endif /* __HWOPS_H__ */
