#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <datalib/usrtc.h>
#include <errno.h>
#include <ipc/port.h>
#include <ipc/channel.h>
#include <ipc/rpc.h>
#include <ns/ns.h>
#include <errno.h>
#include <devio/devio.h>
#include <sys/poll.h>
#include <sys/thread.h>
#include <debug.h>
#include <ns/ns.h>
#include <sys/procmgr.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <pci/pci.h>
#include <sys/ievent.h>
#include <arch/atomic.h>
#include <arch/bitwise.h>
#include <sys/mman.h>

#include "e1000.h"
#include "e1000_hw.h"
#include "e1000_osdep.h"

static int e1000_link_test(struct e1000_adapter *adapter, uint64_t *data)
{
  *data = 0;
  if (adapter->hw.media_type == e1000_media_type_internal_serdes) {
    int i = 0;
    adapter->hw.serdes_link_down = true;

    /* On some blade server designs, link establishment
     * could take as long as 2-3 minutes */
    do {
      e1000_check_for_link(&adapter->hw);
      if (adapter->hw.serdes_link_down == true)
        return *data;
      msleep(20);
    } while (i++ < 3750);
    *data = 1;
  } else {
    e1000_check_for_link(&adapter->hw);
    if (adapter->hw.autoneg)  /* if auto_neg is set wait for it */
      msleep(4000);

    if (!(E1000_READ_REG(&adapter->hw, STATUS) & E1000_STATUS_LU)) {
      *data = 1;
    }
  }
  return *data;
}

int e1000_diag_test(struct e1000_adapter *adapter,bool online, uint64_t *data)
{
  int ret_flags=0;

  arch_bit_set(&adapter->flags,__E1000_TESTING);
  if (!online) { /* Offline tests */
    /* save speed, duplex, autoneg settings */
    uint16_t autoneg_advertised = adapter->hw.autoneg_advertised;
    uint8_t forced_speed_duplex = adapter->hw.forced_speed_duplex;
    uint8_t autoneg = adapter->hw.autoneg;

    console_printf("offline testing starting\n");

    /* Link test performed before hardware reset so autoneg doesn't
     * interfere with test result */
    if (e1000_link_test(adapter, &data[4]))
      ret_flags |= ETH_TEST_FL_FAILED;

    e1000_reset(adapter);

//    if (e1000_intr_test(adapter, &data[2]))
//      ret_flags |= ETH_TEST_FL_FAILED;

//    e1000_reset(adapter);

    /* make sure the phy is powered up */
//    e1000_power_up_phy(adapter);
//    if (e1000_loopback_test(adapter, &data[3]))
//      ret_flags |= ETH_TEST_FL_FAILED;

    /* restore speed, duplex, autoneg settings */
    adapter->hw.autoneg_advertised = autoneg_advertised;
    adapter->hw.forced_speed_duplex = forced_speed_duplex;
    adapter->hw.autoneg = autoneg;

    e1000_reset(adapter);
    arch_bit_clear(&adapter->flags,__E1000_TESTING);
  }
  msleep(4 * 1000);
  return ret_flags;
}
