# Makefile.mk
# Filesystems services makefile
# Originally written by MadTirra <madtirra@jarios.org>
# (c) Jari OS core development team 2005-2008
#

-include ../.config

FS_DEP += libv2.a

# some special filesystems
# Init file system that mount as initial root filesystem
ifeq ($(CONFIG_INITFS),y)
-include filesystems/initfs/Makefile.mk
endif

ifeq ($(CONFIG_TMPFS),y)
-include filesystems/tmpfs/Makefile.mk
endif

ifeq ($(CONFIG_DEVIOFS),y)
-include filesystems/deviofs/Makefile.mk
endif

# special OS filesystems
-include filesystems/os/Makefile.mk

# regular file systems
-include filesystems/regular/Makefile.mk

# network file systems
#-include filesystems/network/Makefile.mk

# file formats file systems
#-include filesystems/fformat/Makefile.mk
