#ifndef DEBUGFS_H
#define DEBUGFS_H

#include <sys/types.h>
#include <sys/stat.h>
#include <vfs/fs.h>

#ifdef EXT2_DEBUG
#include <dircons.h>
#endif

#define DEBUGFS_DEBUG 1

#ifdef DEBUGFS_DEBUG
#include <dircons.h>
#endif

#define FS_DOMAIN "debugfs"

#define fs_warn(_fmt,...)						\
  console_printf("["FS_DOMAIN"] "_fmt"\n", ##__VA_ARGS__)

#ifdef DEBUGFS_DEBUG
  #define console_dprintf(_fmt,...)					\
     console_printf("["FS_DOMAIN"] (%s): "_fmt"\n",__FUNCTION__,	\
		    ##__VA_ARGS__)
  #define fs_dassert(testcase)						\
    do {								\
      if (!(testcase)) {						\
        console_dprintf("Test case failed: %s\n", #testcase);		\
        abort();							\
      }									\
    } while (0)
  #define open_console_d() open_console()
#else
  #define console_dprintf(_fmt,...)
  #define open_console_d()
  #define fs_dassert(testcase)
#endif

#endif
