# Makefile.mk
# Jari OS ext2 filesystem port
# Originally written by Stanislav Ivankin <grepz@jarios.org>
# (c) Jari OS core development team 2005-2008
#

EXT2_OBJS = filesystems/regular/ext2/v2ext2.o filesystems/regular/ext2/ext2.o \
	filesystems/regular/ext2/alloc.o filesystems/regular/ext2/alloc_sb.o \
	filesystems/regular/ext2/alloc_stats.o filesystems/regular/ext2/alloc_tables.o  \
	filesystems/regular/ext2/badblocks.o filesystems/regular/ext2/bb_inode.o \
	filesystems/regular/ext2/bitmaps.o filesystems/regular/ext2/bitops.o \
	filesystems/regular/ext2/block.o filesystems/regular/ext2/bmap.o    \
	filesystems/regular/ext2/check_desc.o filesystems/regular/ext2/closefs.o \
	filesystems/regular/ext2/crc16.o filesystems/regular/ext2/csum.o \
	filesystems/regular/ext2/dblist.o filesystems/regular/ext2/dblist_dir.o \
	filesystems/regular/ext2/dirblock.o filesystems/regular/ext2/dirhash.o \
	filesystems/regular/ext2/dir_iterate.o filesystems/regular/ext2/expanddir.o \
	filesystems/regular/ext2/ext_attr.o filesystems/regular/ext2/extent.o \
	filesystems/regular/ext2/valid_blk.o filesystems/regular/ext2/freefs.o \
	filesystems/regular/ext2/gen_bitmap.o filesystems/regular/ext2/get_pathname.o \
	filesystems/regular/ext2/getsize.o filesystems/regular/ext2/getsectsize.o \
	filesystems/regular/ext2/i_block.o filesystems/regular/ext2/ind_block.o \
	filesystems/regular/ext2/initialize.o filesystems/regular/ext2/inode.o \
	filesystems/regular/ext2/link.o filesystems/regular/ext2/llseek.o \
	filesystems/regular/ext2/lookup.o filesystems/regular/ext2/mkdir.o \
	filesystems/regular/ext2/native.o filesystems/regular/ext2/newdir.o \
	filesystems/regular/ext2/openfs.o filesystems/regular/ext2/read_bb.o \
	filesystems/regular/ext2/read_bb_file.o filesystems/regular/ext2/res_gdt.o \
	filesystems/regular/ext2/rw_bitmaps.o filesystems/regular/ext2/swapfs.o \
	filesystems/regular/ext2/unix_io.o filesystems/regular/ext2/unlink.o \
	filesystems/regular/ext2/namei.o filesystems/regular/ext2/sparse.o \
	filesystems/regular/ext2/inode_cache.o filesystems/regular/ext2/block_cache.o \
	filesystems/regular/ext2/dev_io.o

CLEAN_OBJS += $(EXT2_OBJS)

FSES_STATIC += ext2.fs.static
FSES_DUMP += ext2.dump
FSES_SHARED += ext2.fs

ext2.fs.static: $(FS_DEP) $(EXT2_OBJS)
	$(Q)$(ECHO) "[LD] $@"
	$(Q)$(LD) $(LDFLAGS) -static $(EXT2_OBJS) libmisc.a libv2.a $(LIBS) -o $@

ext2.fs: $(FS_DEP) $(EXT2_OBJS)
	$(Q)$(ECHO) "[LD] $@"
	$(Q)$(LD) $(LDFLAGS) $(EXT2_OBJS) libmisc.a libv2.a $(LIBS) -o $@
