#ifndef DEV_IO_H
#define DEV_IO_H

#include "block_cache.h"

#define EXT2FS_INITIAL_BLOCKSIZE 1024

#define DEV_NAME_LEN 255

/* Used/unused list, upper watermark */
#define CACHE_USED_SIZE   128
#define CACHE_UNUSED_SIZE 64

/* When read/write is equal/biger then this value, do not cache */
#define OVERRIDE_CACHE_OPERATION_SIZE 8

typedef struct __dev_io dev_io_t;
struct __dev_io
{
  char device_name[DEV_NAME_LEN];
  int io_fd;
  uint32_t io_block_size;
  int io_mask;
  off_t io_offset;
  off_t io_init_ofset;
  /* Blocks cache */
  bcache_t bcache;
  /* Stats */
  uint64_t read;
  uint64_t written;
};

dev_io_t *ext2fs_devio_init_io(char *device, int len, uint32_t block_size, off_t init_off, int mask);
off_t ext2fs_devio_llseek(dev_io_t *io, off_t offset, int flag);
ssize_t ext2fs_devio_read_blk(dev_io_t *io, uint32_t start_blk, uint32_t count_blk, void *data);
ssize_t ext2fs_devio_write_blk(dev_io_t *io, uint32_t start_blk, uint32_t count_blk, const void *data);

#endif
