/*
 * getsectsize.c --- get the sector size of a device.
 *
 * Copyright (C) 1995, 1995 Theodore Ts'o.
 * Copyright (C) 2003 VMware, Inc.
 *
 * %Begin-Header%
 * This file may be redistributed under the terms of the GNU Public
 * License.
 * %End-Header%
 */

#define _LARGEFILE_SOURCE
#define _LARGEFILE64_SOURCE

#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#include "ext2_fs.h"
#include "ext2fs.h"

/* TODO: */
errcode_t ext2fs_get_device_sectise(const char *file, int *sectsize)
{
  int fd, err;
  struct stat st;

  fd = open(file, O_RDONLY);
  if (fd < 0)
    return errno;

  if (fstat(fd, &st) < 0) {
    err = errno;
    close(fd);
    return err;
  }

  *sectsize = st.st_blksize;

  close(fd);

  return 0;
}
