/*
 * llseek.c -- stub calling the llseek system call
 *
 * Copyright (C) 1994, 1995, 1996, 1997 Theodore Ts'o.
 *
 * %Begin-Header%
 * This file may be redistributed under the terms of the GNU Public
 * License.
 * %End-Header%
 */

#include <sys/types.h>
#include <errno.h>
#include <unistd.h>
#include "ext2_io.h"

ext2_loff_t ext2fs_llseek (int fd, ext2_loff_t offset, int origin)
{
  if ((sizeof(off_t) < sizeof(ext2_loff_t)) &&
      (offset >= ((ext2_loff_t) 1 << ((sizeof(off_t)*8) -1)))) {
    errno = EINVAL;
    return -1;
  }

  return lseek (fd, (off_t) offset, origin);
}
