#ifndef LOG_H
#define LOG_H

#include <sys/kcontrol.h>

#ifdef CONFIG_EXT2FS_DEBUG
#define EXT2FS_DEBUG
#endif

#ifdef EXT2FS_DEBUG
#define ext2_debug(f, a...)                                             \
  do {                                                                  \
    klog("EXT2-fs DEBUG (%s, %d): %s:",                                 \
         __FILE__, __LINE__, __func__);                                 \
    klog(f"\n", ## a);                                                  \
  } while (0)
#else
#define ext2_debug(f, a...)
#endif

#define ext2_warning(_what,_fmt,...)            \
  klog("[EXT2] ("_what"): "_fmt, ##__VA_ARGS__)

#define ext2_error(_what,_fmt,...)                      \
  do {                                                  \
    klog("[EXT2] ("_what"): "_fmt, ##__VA_ARGS__);      \
    *(int *)0x545 = 0x454;                              \
  } while(0)


#endif
