#ifndef V2EXT2_H
#define V2EXT2_H

#include "dev_io.h"
#include "inode_cache.h"

dev_io_t *ext2_io;
icache_t ext2_icache;

int ext2_mount(vnode_t *node, char *path, int *pps, int pp, int flags);
int ext2_lookup(vnode_t *node, char *path, int *pps, int pp);
int ext2_opendir(vnode_t *node,char *path,int *pps,int pp);
int ext2_readdir(vnode_t *node,size_t size,off_t off,struct dirent *dentry);
int ext2_createdir(vnode_t *node,char *path,int *pps, int pp,int mode,uid_t uid,gid_t gid);
int ext2_write(vnode_t *node,void *buf,size_t *size,off_t offset);
void *ext2_read(vnode_t *node,void *buf,size_t *size,off_t offset);

#endif
