/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007-2009 Jari OS Core Team <http://jarios.org>
 * Copyright (C) 2009 Dmitry Balakshin <balakshin@jarios.org>
 *
 * ISO 9660 CDROM file system
 */

#ifndef __ISOFS_H__
#define __ISOFS_H__

int iso_mount(vnode_t *node, char *path, int *pps, int pp, int flags);
int iso_umount(vnode_t *node);
int iso_lookup(vnode_t *node, char *path, int *pps, int pp);
void* iso_read(vnode_t *node, void *buf, size_t *size, off_t offset);
int iso_opendir(vnode_t *node, char *path, int *pps, int pp);
int iso_close(vnode_t *node);
int iso_setattr(vnode_t *node, uint16_t cmd, ...);
int iso_getattr(vnode_t *node, uint16_t cmd, ...);
int iso_readdir(vnode_t *node, size_t size, off_t off, struct dirent *dentry);

#endif  /* __ISOFS_H__ */
