/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Dmitry Gromada <gromada@jarios.org>
 *
 * ata host driver related stuffs
 */

#ifndef __HOST_DRV_H__
#define __HOST_DRV_H__

#include <stdbool.h>
#include <sys/types.h>
#include "ata.h"

#define INIT_ATA_DRV_FUNCNAME "init_ata_host_driver"

typedef struct __ata_host_driver {
  const char *name;
  int phys_iface;

  int (*scan_hosts)(void);
  int (*init_host)(ata_host_t *host, int num);
  void (*shutdown_host)(ata_host_t *host);
  void (*reset_host)(ata_host_t *host);
} ata_host_driver_t;

/*
 * init ata host driver routine type
 *
 * Return pointer on to driver on success;
 * NULL on fail
 */
typedef ata_host_driver_t *(init_ata_host_driver_t)(void);

#endif /* __HOST_DRV_H__ */
