/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Dmitry Gromada <gromada@jarios.org>
 *
 * Block device driver ralated stuffs
 */

#ifndef __BDEV_DRV_H__
#define __BDEV_DRV_H__

#include <sys/types.h>
#include <block/request.h>
#include "blkdev.h"

#define INIT_BDEV_DRIVER_FUNCTION_NAME "init_block_device_driver"

typedef struct __blkdev_driver {
  const char *name;
  const char *version;
  const char *author;
  const int iface_type;

  /* driver operations */

  int (*scan_ifaces)(void *host_lib_handle);
  int (*init_iface)(void *host_lib_handle, struct bd_iface*,
                    const char *arg_line);
  void (*shutdown_iface)(struct bd_iface*);
  int (*probe)(block_device_t *bdev);
  int (*prepare_rq_proc)(blkreq_queue_t*);
  int (*suspend_device)(block_device_t*);
  int (*resume_device)(block_device_t*);
  void (*shutdown_device)(block_device_t*);
} blkdev_driver_t;

/*
 * init block device driver routine type
 *
 * Return pointer on to driver on success;
 * NULL on fail
 */
typedef blkdev_driver_t *(*init_bdev_driver_t)(void);

#endif /* __BDEV_DRV_H__ */
