/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Dmitry Gromada <gromada@jarios.org>
 *
 * Block device ioctls
 */

#ifndef __BDEV_IOCTL_H__
#define __BDEV_IOCTL_H__

#include <sys/types.h>
#include <ipc/port.h>

#define SERVER_CTLS 0

/* ioctls */
#define BLKIOC_GET_MDATA        _IOR(SERVER_CTLS, CTL_GET_MDATA, struct mdata)
#define BLKIOC_SET_ASYNC_PORT   _IOW(SERVER_CTLS, CTL_SET_ASYNC_PORT, ulong_t)

/* commands */
#define BLK_SERV_GET_MDATA        _IOCMD(SERVER_CTLS, CTL_GET_MDATA)
#define BLK_SERV_SET_ASYNC_PORT   _IOCMD(SERVER_CTLS, CTL_SET_ASYNC_PORT)

#define BDEV_CTLS 2

/* ioctls */
#define BLKIOC_FLUSH            _IO(BDEV_CTLS, CTL_FLUSH)

/* commands */
#define BLKCMD_FLUSH            _IOCMD(BDEV_CTLS, CTL_FLUSH)

/* ioctl numbers */
enum {
  CTL_GET_MDATA,
  CTL_SET_ASYNC_PORT,
};

enum {
  CTL_FLUSH
};

struct mdata {
  sector_t capacity;
  int hw_sect_bits;
  prtid_t cmd_port;
};

#endif /* __BDEV_IOCTL_H__ */
