/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Dmitry Gromada <gromada@jarios.org>
 */

#ifndef __SIGACTION_H__
#define __SIGACTION_H__

#include <sys/types.h>
#include <signal.h>

#define IOSCHED_SIGNO SIGUSR1

/*
 * Set block device sigaction
 *
 * On success returns 0, on error returns -1, and 'errno' contain a respective
 * error code
 */
int set_blk_sigaction(int signo, void (*action)(int, siginfo_t*, void*));

/*
 * Default block I/O scheduler timeout handler
 *
 * 'si_value' field of the 'info' structure must contain
 * pointer to the queue need to be flushed. The queue must be
 * in a block group.
 */
void default_iosched_sigaction(int signo, siginfo_t *info, void *context);

#endif /* __SIGACTION_H__ */
