/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Dmitry Gromada <gromada@jarios.org>
 *
 * Completion notification
 */

#ifndef __SYNC_H__
#define __SYNC_H__

#include <sys/types.h>
#include <unistd.h>

struct completion {
  event_t event;
  ulong_t result;
};

static inline int init_completion(struct completion *c)
{
  c->event.__id = -1;

  return event_init(&c->event);
}

static inline int wait_for_completion(struct completion *c)
{
  return event_wait(&c->event);
}

static inline void destroy_completion(struct completion *c)
{
  if (c->event.__id != -1)
    event_destroy(&c->event);
}

static inline int complete(struct completion *c, ulong_t res)
{
  c->result = res;

  return event_signal(&c->event);
}

#endif
