/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 Dmitry Gromada <gromada@jarios.org>
 * (c) Copyright 2008 Paul Graphov <graphov@jarios.org>
 *
 * Direct output to console function and macros
 */

#ifndef __DIRCONS_H__
#define __DIRCONS_H__

#include <sys/types.h>
#include <stdbool.h>
#include <unistd.h>
#include <devio/devio.h>
#include <arch/atomic.h>
#include "err.h"

#define MAX_CONSOLE_STRLEN 1024

extern const char *error_strings[MAX_ERRNO + 1];

int open_console(void);
int open_serial(void);
void close_console(void);
void console_output(const char *msg);
void console_printf(const char *fmt,... );

#endif
