/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2005,2008 MadTirra <madtirra@jarios.org> 
 *
 * fs resources functions
 * 
 */

#ifndef __FSIO_FS_RESOURCES_H__
#define __FSIO_FS_RESOURCES_H__

#include <sys/types.h>
#include <sys/stat.h>
#include <wchar.h>
#include <datalib/usrtc.h>
#include <pthread.h>

#define DEF_MAXFDS  32

typedef struct __fs_source_t {
  pid_t pid;
  uid_t uid;
  gid_t gid;
  int max_fds;
  int n_fds;
  pthread_mutex_t lock;
  usrtc_t *res;
} fs_source_t;

typedef struct __file_des_t {
  int fd; /* user fd */
  off_t rw_off;
  off_t wr_off;
  fs_source_t *owner;
  vnode_t *vnode;
} file_des_t;

int init_fs_resources(void);
int add_fs_source(fs_source_t*,pid_t,uid_t,gid_t);
int remove_fs_source(pid_t);
int add_file_des(pid_t,uid_t,gid_t,int,vnode_t*);
int rm_file_des(pid_t,int);

#endif /* __FSIO_FS_RESOURCES_H__ */
