/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2005,2008 MadTirra <madtirra@jarios.org> 
 *
 * fs service functions
 * 
 */

#ifndef __VFSIO_FS_SERVICE_H__
#define __VFSIO_FS_SERVICE_H__

#include <sys/types.h>
#include <sys/stat.h>
#include <ipc/port.h>
#include <ipc/channel.h>
#include <wchar.h>

#include <fsio/vfs_call.h>

struct fs_info {
  char *fstype;
  char *author;
  int vt,vmj,vmn;
};

typedef struct fs_raw_task_t {
  int fs_cmd;
  void *msg;
  size_t len;
  pid_t pid;
  uid_t uid;
  gid_t gid;
  int msg_id;
} fs_raw_task_t;

typedef struct fs_mount_task_t {
  char *devno;
} fs_mount_task_t;

int poll_service_port(prtid_t port,void *msgbuf,size_t len,fs_raw_task_t *task);
int poll_general_port(prtid_t port,void *msgbuf,size_t len,fs_raw_task_t *task);

#endif /* __VFSIO_FS_SERVICE_H__ */
