/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2005,2008 MadTirra <madtirra@jarios.org> 
 *
 * vfs calls
 * 
 */

#ifndef __VFSIO_VFS_CALL_H__
#define __VFSIO_VFS_CALL_H__

#include <sys/types.h>
#include <ipc/port.h>
#include <wchar.h>

typedef struct __vfs_reg_head_t {
  pid_t pid;
  prtid_t w_port;
  prtid_t s_port;
  wchar_t *fs_name;
} vfs_reg_head_t;

extern chid_t vfs_channel;

int vfsio_init(void);
int vfs_register(wchar_t *fs_name,prtid_t w_port,prtid_t s_port);
pid_t vfs_ackpid(void);

#endif /* __VFSIO_VFS_CALL_H__ */
