/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Dmitry Gromada <gromada@jarios.org>
 *
 * Timeouts for services
 */

#ifndef __TIMEOUT_H__
#define __TIMEOUT_H__

#include <stdbool.h>
#include <sys/types.h>
#include <time.h>
#include <unistd.h>
#include <pthread.h>

#define MSEC_INFINITE 0xFFFFFFFF

struct timer_desc {
  timer_t id;
  /* moment of timer expiration in system ticks */
  uint64_t exp_ticks;
  int blocked_signo;
};

int init_timeout_tmr(struct timer_desc *tmr, pthread_t thread, int signo,
                     void *sival_ptr, bool block);
void destroy_timeout_tmr(struct timer_desc *tmr);
int set_timeout(struct timer_desc *tmr, uint16_t msec);
int set_timeout_ticks(struct timer_desc *tmr, uint16_t ticks);
int reset_timeout(struct timer_desc *tmr);
uint32_t timeout_expiration(struct timer_desc *tmr);

#endif
