#ifndef FS_H
#define FS_H

/* Inode flags */
/* NOTE: Port from Linux as is to handle hardcoded values */
#define	FS_SECRM_FL        (1<<0) /* Secure deletion */
#define	FS_UNRM_FL         (1<<1) /* Undelete */
#define	FS_COMPR_FL        (1<<2) /* Compress file */
#define FS_SYNC_FL         (1<<3) /* Synchronous updates */
#define FS_IMMUTABLE_FL    (1<<4) /* Immutable file */
#define FS_APPEND_FL       (1<<5) /* writes to file may only append */
#define FS_NODUMP_FL       (1<<6) /* do not dump file */
#define FS_NOATIME_FL      (1<<7) /* do not update atime */
/* Compression flags { */
#define FS_DIRTY_FL        (1<<8)
#define FS_COMPRBLK_FL     (1<<9)  /* One or more compressed clusters */
#define FS_NOCOMP_FL       (1<<10) /* Don't compress */
#define FS_ECOMPR_FL       (1<<11) /* Compression error */
/* } Compression flags */
#define FS_BTREE_FL        (1<<12) /* btree format dir */
#define FS_INDEX_FL        (1<<12) /* hash-indexed directory */
#define FS_IMAGIC_FL       (1<<13) /* AFS directory */
#define FS_JOURNAL_DATA_FL (1<<14) /* Reserved for ext3 */
#define FS_NOTAIL_FL       (1<<15) /* file tail should not be merged */
#define FS_DIRSYNC_FL      (1<<16) /* dirsync behaviour (directories only) */
#define FS_TOPDIR_FL       (1<<17) /* Top of directory hierarchies*/
#define FS_EXTENT_FL       (1<<19) /* Extents */
#define FS_DIRECTIO_FL     (1<<20) /* Use direct i/o */
#define FS_RESERVED_FL     (1<<31) /* reserved for ext2 lib */

#endif
