/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007-2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2005,2008,2009 MadTirra <madtirra@jarios.org>
 *
 * Jari OS virtual file system v2,
 * postponed and non-direct operations
 * queues and implementation
 */

#ifndef __VFS_POLLS_H__
#define __VFS_POLLS_H__

#include <sys/types.h>
#include <stdint.h>
#include <stdarg.h>
#include <stdlib.h>
#include <ipc/port.h>
#include <ipc/channel.h>
#include <ipc/iov.h>
#include <ipc/rpc.h>
#include <pthread.h>
#include <errno.h>
#include <pthread.h>
#include <datalib/usrtc.h>

typedef struct __queue_obj_type {
  int op_id;      /* operation id */
  int msgid;      /* message id */
  uni_rpc_t rpc;  /* RPC call header */
  void *data;     /* specific data for operation */
} queue_obj_t;

typedef struct __queue_pp_type {
  usrtc_t *uds;          /* used data structure */
  pthread_mutex_t lock;  /* lock for queue */
} queue_pp_t;

#define queue_pp_lock(q)    pthread_mutex_lock(&q->lock)
#define queue_pp_unlock(q)  pthread_mutex_unlock(&q->lock)

/* used functions interface */
/* inits postponed calls logic */
int pp_queue_init(void);

/* safe insert to postponed queue */
int pp_queue_insert(int msgid,uni_rpc_t *rpc);

#endif /* __VFS_POLLS_H__ */
