/* Universal posix ACL */

#ifndef POSIX_ACL_H
#define POSIX_ACL_H

#define ACL_UNDEFINED_ID -1

#define ACL_TYPE_DEFAULT (2<<14)
#define ACL_TYPE_ACCESS  (2<<15)

/* Access properties */
#define ACL_USER_OBJ  (1<<0)
#define ACL_USER      (1<<1)
#define ACL_GROUP_OBJ (1<<2)
#define ACL_GROUP     (1<<3)
#define ACL_MASK      (1<<4)
#define ACL_OTHER     (1<<5)

/* Access permissions */
#define ACL_EXEC      (1<<0)
#define ACL_WRITE     (1<<1)
#define ACL_READ      (1<<2)

struct posix_acl_entry {
  short e_tag;
  unsigned short e_perm;
  unsigned int e_id;
};

struct posix_acl {
  atomic_t count;
  unsigned int a_count;
  struct posix_acl_entry a_entries[0];
};

#endif /* POSIX_ACL_H */
