# Makefile.mk
# microkernel block device service library
# 
# Originally written by Dmitry Gromada <gromada@jarios.org>
#

LIBBLKDEV_OBJS = libs/libblkdev/genstor.o libs/libblkdev/server.o \
                 libs/libblkdev/part_scan.o libs/libblkdev/genmap.o \
                 libs/libblkdev/request.o libs/libblkdev/iosched.o \
		 libs/libblkdev/sigaction.o

ifeq ($(CONFIG_BLK_TRACE),y)
  LIBBLKDEV_OBJS += libs/libblkdev/blk_trace.o
endif
ifeq ($(CONFIG_DEADLINE_IOSCHED),y)
  LIBBLKDEV_OBJS += libs/libblkdev/deadline-iosched.o
endif

CLEAN_OBJS += $(LIBBLKDEV_OBJS)

LIBS_STATIC += libblkdev.a

libblkdev.a: $(LIBBLKDEV_OBJS)
	$(Q)$(ECHO) "[AR] libblkdev.a"
	$(Q)$(AR) rc libblkdev.a $(LIBBLKDEV_OBJS)
