/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Dmitry Gromada <gromada@jarios.org>
 */

#include <block/sigaction.h>
#include <block/request.h>
#include <bitwise.h>
#include <debug.h>

int set_blk_sigaction(int signo, void (*action)(int, siginfo_t*, void*))
{
  struct sigaction sa;

  sa.sa_handler = NULL;
  sa.sa_sigaction = action;
  sa.sa_mask = 0;
  sa.sa_flags = SA_SIGINFO;

  return sigaction(signo, &sa, NULL);
}

void default_iosched_sigaction(int signo, siginfo_t *info, void *context)
{
  blkreq_queue_t *q = info->si_value.sival_ptr;
  struct blk_group *group = q->group;

  ASSERT(group, "");

  bit_set(&q->group->flush_mask, q->index);
  if (blk_group_wait(group))
    event_signal(&group->not_empty);
}
