#include <string.h>
#include <stdio.h>
#include <arch/bitwise.h>

#include "lwip/opt.h"
#include "lwip/sys.h"
#include "lwip/netif.h"
#include "netif/etherif.h"
#include "netif/etharp.h"

static long ifbitmask;

#define lock_ether()
#define unlock_ether()

void ether_init(void)
{
  ifbitmask=~(long)0;
}

int etherif_assign_name(struct netif *nif)
{
  long id;

  lock_ether();
  id=arch_bit_find_lsf(ifbitmask);  
  if( id != -1 ) {
    arch_bit_clear(&ifbitmask,id);
  }
  unlock_ether();

  if( id >=0 ) {
    sprintf(nif->name,"%s%d",ETHERIF_NAME_PREFIX,id);
  }
  return (id >=0) ? 0 : -1;
}

int etherif_init_device(struct netif *nif)
{
  if( etherif_assign_name(nif) ) {
    return -1;
  }

  nif->output = etharp_output;
  nif->input = ethernet_input;
  return 0;
}
