/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 MadTirra <madtirra@jarios.org>
 *
 * termio.x:
 *
 */

#include <sys/types.h>
#include <sys/mman.h>
#include <sys/poll.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <wchar.h>
#include <datalib/usrtc.h>
#include <ns/ns.h>
#include <ipc/rpc.h>
#include <devio/devio.h>
#include <sys/console.h>

#include "debug.h"
#include "termio.h"

wchar_t *cdebugbuf=NULL;
cschar_t *dbuf=NULL;

void ascii_puts(const wchar_t *msg)
{
  int r=0;
  int len=wcslen(msg);
  int i;
  union colb a;

  for(i=0;i<len;i++) {
    dbuf[i].ch=(wchar_t)msg[i];
    a.fg=TC_RED;
    a.bg=0;
    dbuf[i].cattr=a.val;
    dbuf[i].xattr=0;
  }

  r=write(consolefd,dbuf,len*sizeof(*dbuf));

  return;
}

void debug_init(void)
{
  dbuf=malloc(1024*sizeof(cschar_t)+sizeof(uni_rpc_t));
  cdebugbuf=malloc(1024*sizeof(wchar_t));
  if(!cdebugbuf || !dbuf)
    abort();
  else
    memset(cdebugbuf,'\0',1024);

  return;
}

void ascii_printf(const wchar_t *fmt,... )
{
  va_list ap;

  memset(cdebugbuf,'\0',1024*sizeof(wchar_t));
  
  va_start(ap, fmt);
  vswprintf(cdebugbuf, 1024, fmt, ap);
  va_end(ap);

  ascii_puts(cdebugbuf);

  return;
}

