/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 Graphov Paul <graphov@jarios.org>
 * 
 * Fallback layout for at/xt keyboard. Is used when selected layout
 * doesn't provide ascii chars for keycode. Useful for common keys
 * like arrows, etc.
 *
 */

#include <sys/types.h>
#include <ctype.h>
#include <sys/keyboard.h>

#include "keyb.h"
#include "en_layout.h"

int fb_scan_to_ascii(char *buf, uint8_t scancode, uint8_t comb_flags, uint8_t state_flags)
{
  if(comb_flags || state_flags) return 0;
  
  switch(scancode) {
    case KC_UP:
      buf[0] = 27;
      buf[1] = 91;
      buf[2] = 65;
      return 3;
    case KC_DOWN:
      buf[0] = 27;
      buf[1] = 91;
      buf[2] = 66;
      return 3;
    case KC_LEFT:
      buf[0] = 27;
      buf[1] = 91;
      buf[2] = 68;
      return 3;
    case KC_RIGHT:
      buf[0] = 27;
      buf[1] = 91;
      buf[2] = 67;
      return 3;
    case KC_PGUP:
      buf[0] = 27;
      buf[1] = 91;
      buf[2] = 53;
      buf[2] = 126;
      return 4;
    case KC_PGDN:
      buf[0] = 27;
      buf[1] = 91;
      buf[2] = 54;
      buf[2] = 126;
      return 4;
    case KC_HOME:
      buf[0] = 27;
      buf[1] = 91;
      buf[2] = 55;
      buf[2] = 126;
      return 4;
    case KC_END:
      buf[0] = 27;
      buf[1] = 91;
      buf[2] = 56;
      buf[2] = 126;
      return 4;
  }
  return 0;
}
