/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 MadTirra <madtirra@jarios.org>
 *
 * termio.x:
 * keyb.h: physical input ops
 *
 */

#ifndef __TERMIO_KEYB_H__
#define __TERMIO_KEYB_H__

#include <sys/types.h>

//#define EXT1_MASK    0x0001
//#define EXT2_MASK    0x0002


#define NOSPACE     -1000

typedef struct __keypress {
  uint32_t scancode;
  uint8_t comb_flags;
  uint8_t state_flags;
} keypress_t;

void init_keyb(void);
int fb_scan_to_ascii(char *buf, uint8_t scancode, uint8_t comb_flags, uint8_t state_flags);
void *keyb_thread(void *data);

#endif /* __TERMIO_KEYB_H__ */
