/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2005,2008 MadTirra <madtirra@jarios.org>
 *
 * Jari OS virtual file system,
 * support routines
 *
 */

#include <sys/types.h>
#include <sys/mman.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <wchar.h>
#include <datalib/usrtc.h>
#include <errno.h>
#include <unistd.h>
#include <ipc/port.h>
#include <ipc/channel.h>
#include <ipc/rpc.h>
#include <ipc/iov.h>
#include <ns/ns.h>
#include <pthread.h>
#include <termio/term.h>

/* services headers */
#include <fsio/vfs_call.h>

/* local headers */
#include "vfs_glob.h"
#include "vfs_rpc.h"

ulong_t hash_s(const char *name)
{
  ulong_t hash=0;

  if(!name)
    return 0;

  while(*name) 
    hash=(hash << 5) + hash + *name++;
  
  return hash;
}

ulong_t hash_w(const wchar_t *name)
{
  ulong_t hash=0;
  char *_name=(char *)name;

  if(!name)
    return 0;

  while(*_name) 
    hash=(hash << 5) + hash + *_name++;
  
  return hash;
}
