# Makefile.mk
# microkernel block devices service
# Originally written by Dmitry Gromada <gromada@jarios.org>
# (c) Jari OS core development team 2005-2009
#

BDEV_OBJS = services/system/bdev/main.o services/system/bdev/server.o

ifeq ($(CONFIG_BDEV_STATLINK), y)
  ifeq ($(CONFIG_ATA_STATLINK), y)
    BDEV_LIBS += atadrv.a libata.a
  endif
endif

BDEV_LIBS += libblkdev.a libmisc.a
CLEAN_OBJS += $(BLKX_OBJS)

SERVICES_STATIC += bdev.x.static
SERVICES_DUMP += bdev.dump
SERVICES_SHARED += bdev.x

bdev.x.static: $(BDEV_OBJS) libblkdev.a atadrv.a
	$(Q)$(ECHO) "[LD] $@"
	$(Q)$(LD) $(LDFLAGS) -static $(BDEV_OBJS) $(BDEV_LIBS) -lpci $(LIBS) -o $@

bdev.x: $(BDEV_OBJS) libblkdev.a atadrv.a
	$(Q)$(ECHO) "[LD] $@"
	$(Q)$(LD) $(LDFLAGS) $(BDEV_OBJS) $(BDEV_LIBS) -lpci $(LIBS) -o $@
