/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Dmitry Gromada <gromada@jarios.org>
 */

#ifndef __BDEV_SERVER_H__
#define __BDEV_SERVER_H__

#include <sys/types.h>
#include <block/blkdev.h>
#include <datalib/usrtc.h>

struct iface_entry {
  /* driver related id */
  int drv_id;
  int abs_id;
  int bus;
  char *drv_name;
  /* interface server pid; 0 if inactive */
  pid_t srv_pid;
  ulong_t port;
};

struct iface_type {
  ulong_t free_indexes;
  int nr_devices;
  usrtc_t ifaces;
};

int init_subsys_reginfo(void);
int start_subsystem_server(void);
int start_interface_server(struct bd_iface *iface, int index);

int find_reserve_iface_index(int iface_type);
void free_iface_index(int iface_type, int index);
void write_iface_ndevs(int *ndevs);
void get_iface_ndevs(int *ndevs);

#endif
