# Makefile.mk
# microkernel bootstrap daemon
# Originally written by MadTirra <madtirra@jarios.org>
# (c) Jari OS core development team 2005-2009
#

BTSD_OBJS = services/system/bootsd/btsd.o services/system/bootsd/syntax.o

BTSD_CONFIG = services/system/bootsd/config/init.scm
BTSD_DEFAULT_CONFIG = services/system/bootsd/config/init.default.scm

CLEAN_OBJS += $(BTSD_OBJS)

SERVICES_STATIC += btsd.x.static
SERVICES_DUMP += btsd.dump
INSTALL_CONFIGS += btsd_install_configs

btsd_install_configs:
	$(Q)$(ECHO) "[INS] Installing bootstrapper config ..." 
	$(Q)mkdir -p $(CONFIG_INITFS_PATH)/etc/
	$(Q)cp $(BTSD_CONFIG) $(CONFIG_INITFS_PATH)/etc/init.scm

btsd.x.static: $(BTSD_OBJS)
	$(Q)$(ECHO) "[LD] $@"
	$(Q)$(LD) $(LDFLAGS) -static $(BTSD_OBJS) libmisc.a -lsexpr $(LIBS) -o $@
	$(Q)test -e $(BTSD_CONFIG) || cp $(BTSD_DEFAULT_CONFIG) $(BTSD_CONFIG)
