/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Stanislav M. Ivankin <grepz@jarios.org>
 *
 * bootstrap service
 *
 */

#ifndef BTSD_H
#define BTSD_H

#include <stdint.h>
#include <datalib/usrtc.h>
#include "syntax_defaults.h"

#define CONFFILE "/etc/init.scm"

#define MODE (S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH)

/* TODO: Reimplement as DAWG later */

typedef struct __btsd_module btsd_module_t;
struct __btsd_module
{
  char name[TOKEN_LENGTH];
  char binary[DQUOTE_LENGTH];
};

typedef struct __btsd_runlevel_module btsd_runlevel_module_t;
struct __btsd_runlevel_module {
  char name[TOKEN_LENGTH];
  int param_num;
  char **params;
} *modules;

typedef struct __btsd_runlevel btsd_runlevel_t;
struct __btsd_runlevel
{
  unsigned int runlevel;
  unsigned int modules_num;
  btsd_runlevel_module_t *modules;
};

typedef struct __btsd_runlevel_conf btsd_runlevel_conf_t;
struct __btsd_runlevel_conf
{
  char name[TOKEN_LENGTH];
  usrtc_t *runlevels;
};

void delete_list(usrtc_t *list);
usrtc_t *init_list(int (*list_cmp)(const void *a, const void *b),
		   void (*list_node_delete)(void *module, usrtc_node_t *node));
usrtc_t *init_module_list(void);

#endif
