# Makefile.mk
# microkernel file system linker daemon
# Originally written by MadTirra <madtirra@jarios.org>
# (c) Jari OS core development team 2005-2009
#

FSLINKER_OBJS = services/system/fslinker/fslinker.o

CLEAN_OBJS += $(FSLINKER_OBJS)

SERVICES_STATIC += fslinker.x.static
SERVICES_DUMP += fslinkerd.dump
SERVICES_SHARED += fslinker.x
INSTALL_CONFIGS += fslinker_install_configs

fslinker_install_configs:
	$(Q)$(ECHO) "[INS] Installing fslinker config ..." 
	$(Q)mkdir -p $(CONFIG_INITFS_PATH)/etc/
	$(Q)cp services/system/fslinker/config/fslinks.default.scm $(CONFIG_INITFS_PATH)/etc/fslinks.scm

fslinker.x.static: $(FSLINKER_OBJS)
	$(Q)$(ECHO) "[LD] $@"
	$(Q)$(LD) $(LDFLAGS) -static $(FSLINKER_OBJS) libmisc.a $(LIBS) -o $@

fslinker.x: $(FSLINKER_OBJS)
	$(Q)$(ECHO) "[LD] $@"
	$(Q)$(LD) $(LDFLAGS) $(FSLINKER_OBJS) libmisc.a $(LIBS) -o $@
