#ifndef FSLINKER_INT_H
#define FSLINKER_INT_H

#include <sys/fslinker.h>

/* If FS is mounted and persists with FSLINK_HANDLE_RECONF
 * flag, then it may be remounted and reconfigured.
 */
typedef enum {
  FSLINK_HANDLE_NOT    = (1<<0),
  FSLINK_HANDLE_CONF   = (1<<1),
  FSLINK_HANDLE_RECONF = (1<<2),
} fsl_module_handle_t;

typedef struct __fsl_modules fsl_modules_t;
struct __fsl_modules {
  char *module;
  char *binary;
  int fs_handle;
};

/* If only 1 path where set, we will try to determine path type
 * from config file
 */
typedef struct __fsl_requested fsl_requested_t;
struct __fsl_requested
{
  fs_link_req_t req;
  char *fstype;

  fs_link_pp_t mounts;
  fs_link_pp_t mountp;

  char **options;
};

#endif
