# Makefile.mk for tests
# Originally written by Alfeiks Kaanoken <madtirra@jarios.org>
#

TEST_MMAP_OBJS = tests/mmap_file.o
TEST_FCNTL_OBJS = tests/fcntl_test.o
TEST_LIBBLKDEV_OBJS = tests/t_libblkdev.o
TEST_PTIMERS_OBJS = tests/t_ptimers.o
TEST_SIGNALS_OBJS = tests/t_signals.o

-include tests/mm/Makefile.mk

CLEAN_OBJS += $(TEST_MMAP_OBJS) $(TEST_FCNTL_OBJS) $(TEST_PTIMERS_OBJS) $(TEST_SIGNALS_OBJS)

BUILD_APPS += mmap_file fcntl_test t_libblkdev t_ptimers t_signals
INSTALL_BIN += mmap_file fcntl_test t_libblkdev t_ptimers t_signals

mmap_file: $(TEST_MMAP_OBJS)
	$(Q)$(ECHO) "[LD] mmap_file"
	$(Q)$(LD) $(LDFLAGS) $(TEST_MMAP_OBJS) $(LIBS) -o $@

fcntl_test: $(TEST_FCNTL_OBJS)
	$(Q)$(ECHO) "[LD] fcntl_test"
	$(Q)$(LD) $(LDFLAGS) $(TEST_FCNTL_OBJS) $(LIBS) -o $@

t_libblkdev: $(TEST_LIBBLKDEV_OBJS)
	$(Q)$(ECHO) "[LD] t_libblkdev"
	$(Q)$(LD) $(LDFLAGS) $(TEST_LIBBLKDEV_OBJS) -ltest $(LIBS) -o $@

t_ptimers: $(TEST_PTIMERS_OBJS)
	$(Q)$(ECHO) "[LD] t_ptimers"
	$(Q)$(LD) $(LDFLAGS) $(TEST_PTIMERS_OBJS) -ltest $(LIBS) -o $@

t_signals: $(TEST_SIGNALS_OBJS)
	$(Q)$(ECHO) "[LD] t_signals"
	$(Q)$(LD) $(LDFLAGS) $(TEST_SIGNALS_OBJS) -ltest $(LIBS) -o $@

