/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2005,2008,2009 MadTirra <madtirra@jarios.org>
 *
 * Jari OS test for fcntls
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <errno.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/utsname.h>
#include <fcntl.h>
#include <dirent.h>
#include <limits.h>
#include <string.h>
#include <unistd.h>
#include <getopt.h>

#define PROGRAM_NAME "fcntl_test"

#define AUTHORS  "Alfeiks Kaanoken"

#define no_argument  0

void usage(int status)
{
  printf("Usage!\n");
  exit (status);
}

#define TEST_DUP     0x1
#define TEST_GETSET  0x2

int main(int argc,char **argv)
{
  int c,fd;
  int ttype=TEST_DUP;

  static struct option const long_options[] = {
    {"show-all", no_argument, NULL, 'a'},
    //    {GETOPT_HELP_OPTION_DECL},
    //    {GETOPT_VERSION_OPTION_DECL},
    {NULL, 0, NULL, 0}
  };

  while ((c = getopt_long (argc, argv, "ad", long_options, NULL))
	 != -1) {
    switch(c) {
    case 'a':
      break;
    case 'd':
      ttype=TEST_DUP;
      break;
    default:
      usage(EXIT_FAILURE);
    }
  }

  int err;
  
  switch(ttype) {
  case TEST_DUP:
    fd=creat("/tmp/dup.log",S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
    fprintf(stdout,"This line going to default stuff\n");
    err=dup2(fd,1);
    fprintf(stderr,"err = %d errno=%d\n",err,errno);
    write(1,"Bla bla test\nfucking test\n",strlen("Bla bla test\nfucking test\n"));
    exit(0);
    break;
  default:
    return EXIT_FAILURE;
  }

  return EXIT_SUCCESS;
}
