#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <test/framework.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/thread.h>
#include <sys/syscall.h>
#include <sys/scheduler.h>
#include <sys/types.h>
#include <sys/wait.h>

#define NUM_ITERS 500
#define EXEC_APP "/bin/tmp.x"

void TC_fork_test(long *unused)
{
  int chpid, i, stat = 0;

  for (i = 0; i < NUM_ITERS; i++) {
    printf("==> %d\n", i);
    chpid = fork();
    switch (chpid) {
        case 0:
          printf("I'm a child %d borned by pid %d\n", getpid(), getppid());
          printf("And now I'm going to exec %s!\n", EXEC_APP);
          execve(EXEC_APP, NULL, NULL);
        case -1:
          printf("Fork (iter=%d) failed. ERRNO = %d\n", i, errno);
          abort();
        default:
          printf("I'm parent of %d...\n", chpid);
          waitpid(chpid, &stat, 0);
          if (stat != 0) {
            printf("Something wrong occured with my poor child :( CODE = %d\n", stat);
            abort();
          }
    }
  }

  printf("Time to die.\n");
  __syscall1(SC_EXIT, 0);
}

test_struct_t test_struct = {
  .pause_seconds = 1,
  .cases = {
    {
      .name = "simple_fork_test",
      .function = TC_fork_test,
      .description = "Very simple fork test...",
      .nolaunch_on_fails = false,
      .abort_on_fail = true,
      .arg_list = ARG_LIST { "fake", ARG_LIST_END },
      .args = ARGS_CHAIN {
        ARGS { 0 },
        ARGS_END,
      },
    },

    CASE_LIST_END,
  },
};
