/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2005,2008,2009 MadTirra <madtirra@jarios.org>
 *
 * Jari OS test for mapping file
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <errno.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/utsname.h>
#include <fcntl.h>
#include <dirent.h>
#include <limits.h>
#include <string.h>
#include <unistd.h>
#include <getopt.h>

#define PROGRAM_NAME "mmap_file"

#define AUTHORS  "Alfeiks Kaanoken"

#define no_argument  0

void usage(int status)
{
  printf("Usage!\n");
  exit (status);
}

int main(int argc,char **argv)
{
  int c;

  static struct option const long_options[] = {
    {"show-all", no_argument, NULL, 'a'},
    //    {GETOPT_HELP_OPTION_DECL},
    //    {GETOPT_VERSION_OPTION_DECL},
    {NULL, 0, NULL, 0}
  };

  while ((c = getopt_long (argc, argv, "amnrsv", long_options, NULL))
	 != -1) {
    switch(c) {
    case 'a':
      break;
    case 'm':
      break;
    case 'n':
      break;
    case 'r':
      break;
    case 's':
      break;
    case 'v':
      break;
    default:
      usage(EXIT_FAILURE);
    }
  }

  if(argc<2)
    usage(EXIT_FAILURE);

  int fd=open(argv[1],O_RDONLY);
  char *addr;
  char *pgbuf=malloc(4097);
  int pg_amount=0,i,*ch;
  struct stat sbuf;

  if(pgbuf==NULL) abort();
  memset(pgbuf,0,4097);

  if(fd<0)
    printf("Cannot open file \n");
  else {
    fstat(fd,&sbuf);
    addr=mmap(NULL,sbuf.st_size,PROT_READ,MAP_SHARED,fd,0);
    pg_amount=sbuf.st_size/PAGE_SIZE;
    if(sbuf.st_size%PAGE_SIZE) pg_amount++;
    if(addr!=MAP_FAILED) {
      for(i=0;i<1000;i++) {
        ch=(int *)addr;
        if(ch[0]!=i) printf("incorrect data\n");
        else printf("pg #%d ok\n",i);
        addr+=PAGE_SIZE;
      }
    } else fprintf(stdout,"mmap of file failed (%d).\n",errno);
  }

  //  fprintf(stdout,"Exiting\n");

  return EXIT_SUCCESS;
}
