# Makefile.mk for Jari OS core utils
# Partially ported core utils
# 
# (c) Jari OS Core Team 2005-2009 <http://jarios.org>
# Originally written by Alfeiks Kaanoken <madtirra@jarios.org>
#

COREUTILS_LIB_OBJS = utils/core/src/system.o utils/core/src/xstrtol.o utils/core/src/xstrtoumax.o \
	utils/core/src/lib/quote.o utils/core/src/lib/quotearg.o utils/core/src/lib/xalloc-die.o \
	utils/core/src/lib/xmalloc.o utils/core/src/lib/full-write.o utils/core/src/lib/safe-read.o \
	utils/core/src/lib/full-read.o utils/core/src/lib/safe-write.o \
	utils/core/src/lib/offtostr.o utils/core/src/lib/umaxtostr.o \
	utils/core/src/lib/strnumcmp.o utils/core/src/lib/xfreopen.o \
	utils/core/src/lib/error.o utils/core/src/lib/progname.o \
	utils/core/src/lib/version-etc-fsf.o utils/core/src/xstrtoimax.o \
	utils/core/src/lib/version-etc.o utils/core/src/lib/long-options.o \
	utils/core/src/lib/imaxtostr.o utils/core/src/lib/strintcmp.o \
	utils/core/src/lib/openat.o utils/core/src/lib/dirname.o \
	utils/core/src/lib/open-safer.o utils/core/src/lib/openat-proc.o \
	utils/core/src/lib/save-cwd.o utils/core/src/lib/chdir-long.o \
	utils/core/src/lib/xgetcwd.o utils/core/src/lib/openat-die.o \
	utils/core/src/lib/exitfail.o utils/core/src/lib/basename.o \
	utils/core/src/lib/xstrndup.o utils/core/src/lib/fd-safer.o \
	utils/core/src/lib/dup-safer.o utils/core/src/lib/stripslash.o \
	utils/core/src/lib/mkdir-p.o utils/core/src/lib/dirchownmod.o \
	utils/core/src/lib/mkancesdirs.o utils/core/src/lib/savewd.o \
	utils/core/src/lib/modechange.o utils/core/src/lib/base64.o \
	utils/core/src/lib/filemode.o utils/core/src/lib/filetype.o \
	utils/core/src/lib/c-strtod.o utils/core/src/lib/c-strtold.o \
	utils/core/src/lib/xstrtod.o utils/core/src/lib/xnanosleep.o \
	utils/core/src/lib/argmatch.o utils/core/src/lib/fd-reopen.o \
	utils/core/src/lib/posixtm.o utils/core/src/lib/posixver.o \
	utils/core/src/lib/utimens.o

COREUTILS_ECHO_OBJS = $(COREUTILS_LIB_OBJS) utils/core/src/echo.o
COREUTILS_CAT_OBJS = $(COREUTILS_LIB_OBJS) utils/core/src/cat.o
COREUTILS_LS_OBJS = $(COREUTILS_LIB_OBJS) utils/core/src/ls.o
COREUTILS_UNAME_OBJS = utils/core/src/uname.o
COREUTILS_HEAD_OBJS = $(COREUTILS_LIB_OBJS) utils/core/src/head.o
COREUTILS_EXPR_OBJS = $(COREUTILS_LIB_OBJS) utils/core/src/expr.o
COREUTILS_TEST_OBJS = $(COREUTILS_LIB_OBJS) utils/core/src/test.o
COREUTILS_RMDIR_OBJS = $(COREUTILS_LIB_OBJS) utils/core/src/rmdir.o
COREUTILS_MKDIR_OBJS = $(COREUTILS_LIB_OBJS) utils/core/src/mkdir.o
COREUTILS_BASE64_OBJS = $(COREUTILS_LIB_OBJS) utils/core/src/base64.o
COREUTILS_SLEEP_OBJS = $(COREUTILS_LIB_OBJS) utils/core/src/sleep.o
COREUTILS_PASTE_OBJS = $(COREUTILS_LIB_OBJS) utils/core/src/paste.o
COREUTILS_TOUCH_OBJS = $(COREUTILS_LIB_OBJS) utils/core/src/touch.o

CLEAN_OBJS += $(COREUTILS_ECHO_OBJS) $(COREUTILS_CAT_OBJS) \
	$(COREUTILS_LS_OBJS) $(COREUTILS_UNAME_OBJS) $(COREUTILS_HEAD_OBJS) \
	$(COREUTILS_EXPR_OBJS) $(COREUTILS_RMDIR_OBJS) $(COREUTILS_MKDIR_OBJS) \
	$(COREUTILS_TEST_OBJS) $(COREUTILS_BASE64_OBJS) $(COREUTILS_SLEEP_OBJS) \
	$(COREUTILS_PASTE_OBJS) $(COREUTILS_TOUCH_OBJS)

BUILD_APPS += echo cat ls uname head expr test rmdir mkdir base64 sleep paste touch
INSTALL_BIN += echo cat ls uname head expr test rmdir mkdir base64 sleep paste touch

echo: $(COREUTILS_ECHO_OBJS)
	$(Q)$(ECHO) "[LD] echo"
	$(Q)$(LD) $(LDFLAGS) $(COREUTILS_ECHO_OBJS) $(LIBS) -o $@

cat: $(COREUTILS_CAT_OBJS)
	$(Q)$(ECHO) "[LD] cat"
	$(Q)$(LD) $(LDFLAGS) $(COREUTILS_CAT_OBJS) $(LIBS) -o $@

head: $(COREUTILS_HEAD_OBJS)
	$(Q)$(ECHO) "[LD] head"
	$(Q)$(LD) $(LDFLAGS) $(COREUTILS_HEAD_OBJS) $(LIBS) -o $@

expr: $(COREUTILS_EXPR_OBJS)
	$(Q)$(ECHO) "[LD] expr"
	$(Q)$(LD) $(LDFLAGS) $(COREUTILS_EXPR_OBJS) $(LIBS) -o $@

test: $(COREUTILS_TEST_OBJS)
	$(Q)$(ECHO) "[LD] test"
	$(Q)$(LD) $(LDFLAGS) $(COREUTILS_TEST_OBJS) $(LIBS) -o $@

ls: $(COREUTILS_LS_OBJS)
	$(Q)$(ECHO) "[LD] ls"
	$(Q)$(LD) $(LDFLAGS) $(COREUTILS_LS_OBJS) $(LIBS) -o $@

uname: $(COREUTILS_UNAME_OBJS)
	$(Q)$(ECHO) "[LD] uname"
	$(Q)$(LD) $(LDFLAGS) $(COREUTILS_UNAME_OBJS) $(LIBS) -o $@

rmdir: $(COREUTILS_RMDIR_OBJS)
	$(Q)$(ECHO) "[LD] rmdir"
	$(Q)$(LD) $(LDFLAGS) $(COREUTILS_RMDIR_OBJS) $(LIBS) -o $@

mkdir: $(COREUTILS_MKDIR_OBJS)
	$(Q)$(ECHO) "[LD] mkdir"
	$(Q)$(LD) $(LDFLAGS) $(COREUTILS_MKDIR_OBJS) $(LIBS) -o $@

base64: $(COREUTILS_BASE64_OBJS)
	$(Q)$(ECHO) "[LD] base64"
	$(Q)$(LD) $(LDFLAGS) $(COREUTILS_BASE64_OBJS) $(LIBS) -o $@

sleep: $(COREUTILS_SLEEP_OBJS)
	$(Q)$(ECHO) "[LD] sleep"
	$(Q)$(LD) $(LDFLAGS) $(COREUTILS_SLEEP_OBJS) $(LIBS) -o $@

paste: $(COREUTILS_PASTE_OBJS)
	$(Q)$(ECHO) "[LD] paste"
	$(Q)$(LD) $(LDFLAGS) $(COREUTILS_PASTE_OBJS) $(LIBS) -o $@

touch: $(COREUTILS_TOUCH_OBJS)
	$(Q)$(ECHO) "[LD] touch"
	$(Q)$(LD) $(LDFLAGS) $(COREUTILS_TOUCH_OBJS) $(LIBS) -o $@
