/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2005,2008,2009 MadTirra <madtirra@jarios.org>
 *
 * Jari OS specific defines and functions for GNU coreutils
 *
 */

#ifndef __COREUTILS_CONFIG_H__
#define __COREUTILS_CONFIG_H__

#include <stdbool.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>

#include "lib/strnumcmp-in.h"
#include "lib/quote.h"
#include "lib/inttostr.h"
#include "lib/xfreopen.h"
#include "lib/full-read.h"

#define program_name PROGRAM_NAME
#define _(n)  n
#define N_(n)  n

#define HELP_OPTION_DESCRIPTION     "Jari OS GNU coreutils help"
#define VERSION_OPTION_DESCRIPTION  " Jari OS v0.0.1a"
#define USAGE_BUILTIN_WARNING       ""

#define Version  "7.2-JariOS 0.0.1"
#define VERSION  Version

#define PACKAGE            "jariutils"
#define PACKAGE_BUGREPORT  "madtirra@jarios.org"
#define PACKAGE_NAME       "Jari OS GNU coreutils"

#define STREQ(a,b)  ((strcmp(a,b)==0) ? true : false)

#define HAVE_INLINE  1

#define RMDIR_ERRNO_NOT_EMPTY ENOTEMPTY

#define __OPENAT_PREFIX

#define HAVE_UTIME_H 1
#define HAVE_STRUCT_UTIMBUF 1

#endif
