/* filemode.c -- make a string describing file modes

   Copyright (C) 1985, 1990, 1993, 1998-2000, 2004, 2006 Free Software
   Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

#include "../config.h"
#include "filetype.h"

char const *file_type (struct stat const *statbuf)
{
  if (S_ISREG (statbuf->st_mode))
    return statbuf->st_size == 0 ? "regular empty file" : "regular file";

  if (S_ISDIR (statbuf->st_mode))
    return "directory";

  if (S_ISBLK (statbuf->st_mode))
    return "block special file";

  if (S_ISCHR (statbuf->st_mode))
    return "character special file";

  if (S_ISFIFO (statbuf->st_mode))
    return "fifo";

  if (S_ISLNK (statbuf->st_mode))
    return "symbolic link";

  if (S_ISSOCK (statbuf->st_mode))
    return "socket";
  /*
  if (S_TYPEISMQ (statbuf))
    return "message queue";

  if (S_TYPEISSEM (statbuf))
    return "semaphore";

  if (S_TYPEISSHM (statbuf))
    return "shared memory object";

  if (S_TYPEISTMO (statbuf))
    return "typed memory object";
  */

  return "weird file";
}
