/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2005,2008,2009 MadTirra <madtirra@jarios.org>
 *
 * Jari OS specific functions for GNU coreutils
 *
 */

#include "system.h"
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <unistd.h>
#include <errno.h>
#include <sys/mman.h>
#include <sys/stat.h>

#include "lib/error.h"

/* local functions prototypes */
static void error_tail(int status, int errnum, const char *message, va_list args);

/* file io specific */
size_t io_blksize(struct stat fstat) /* TODO: make it more sophiscated */
{
  return 4096;
}

/* memory related functions */
size_t getpagesize(void)
{
  return PAGE_SIZE;
}


const char *proper_name(const char *nm)
{
  return nm;
}

/* local functions implementations */
static void error_tail(int status, int errnum, const char *message, va_list args)
{
  vfprintf (stderr, message, args);
  va_end (args);
  /*  if (errnum)
      print_errno_message (errnum);*/
  fflush (stderr);
  if (status)
    exit (status);

  return;
}
