# Makefile.mk for Jari OS system utils
# Jari OS system utils.
# 
# (c) Jari OS Core Team 2005-2009 <http://jarios.org>
# Originally written by Stanislav Ivankin <grepz@jarios.org>
#

SYSTEMUTILS_FSLINK_OBJS = utils/system/src/fslink.o
SYSTEMUTILS_LSPCI_OBJS = utils/system/src/lspci.o
SYSTEMUTILS_TRACE_CAT_OBJS = utils/system/src/trace_cat.o
SYSTEMUTILS_WHOAMI_OBJS = utils/system/src/whoami.o

CLEAN_OBJS += $(SYSTEMUTILS_FSLINK_OBJS) $(SYSTEMUTILS_LSPCI_OBJS) $(SYSTEMUTILS_WHOAMI_OBJS) \
              $(SYSTEMUTILS_TRACE_CAT_OBJS)

BUILD_APPS += fslink lspci trace_cat whoami
INSTALL_BIN += fslink lspci trace_cat whoami

fslink: $(SYSTEMUTILS_FSLINK_OBJS)
	$(Q)$(ECHO) "[LD] fslink"
	$(Q)$(LD) $(LDFLAGS) $(SYSTEMUTILS_FSLINK_OBJS) -ljosconf -lsexpr $(LIBS) -o $@

lspci: $(SYSTEMUTILS_LSPCI_OBJS)
	$(Q)$(ECHO) "[LD] lspci"
	$(Q)$(LD) $(LDFLAGS) $(SYSTEMUTILS_LSPCI_OBJS) -lpci $(LIBS) -o $@

trace_cat: $(SYSTEMUTILS_TRACE_CAT_OBJS)
	$(Q)$(ECHO) "[LD] trace_cat"
	$(Q)$(LD) $(LDFLAGS) $(SYSTEMUTILS_TRACE_CAT_OBJS) $(LIBS) -o $@

whoami: $(SYSTEMUTILS_WHOAMI_OBJS)
	$(Q)$(ECHO) "[LD] $@"
	$(Q)$(LD) $(LDFLAGS) $(SYSTEMUTILS_WHOAMI_OBJS) $(LIBS) -o $@
