#include <sys/types.h>
#include <wchar.h>
#include <string.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <errno.h>
#include <signal.h>

int main(void)
{
  int ret;

  pid_t f, p;
  int r, sn = -1;
  sigset_t set;
  siginfo_t info;
  struct sigaction action;

  sigemptyset(&set);
  sigaddset(&set,SIGUSR2);

  sigemptyset(&action.sa_mask);
  action.sa_flags = 0;
  action.sa_handler = &serv_sig;
  sigaction(SIGUSR2, &action, NULL);

  sigprocmask(SIGUSR2, &set, NULL );


  f = fork();
  if(f < 0) abort();
  if(f == 0) {

  ret = con_init();
  if(ret != 0) {
    abort();
  }

  ret = init_simple_device_server(65536, 65536, DRVNAME, DEVNAME, &dev_op);

  if(ret != 0) {
    abort();
  }

  klog("%d\n", getppid());
  kill(getppid(), SIGUSR2);
  device_server_start();

  // Unreachable under normal circumstances
  abort();
  return 0;

  } else {
    sleep(1);
    r=sigwaitinfo(&set, &info);
    return 0;
  }
}
