# Makefile.mk (libvm86)
# Real mode x86 emulation library
# Originally written by MadTirra <madtirra@jarios.org>
# (c) Jari OS core development team 2005-2008
#

-include ../../config

LIBINT10_OBJS += extra/libint10/lib/int10.o

CFLAGS += -Iextra/libvm86/include -Iextra/libint10/include

CLEAN_OBJS += $(LIBINT10_OBJS)

BUILD_LIBS += libint10.a

BUILD_SO += libint10.so

libint10.a: $(BUILD_DEPS) $(LIBINT10_OBJS)
	$(Q)$(ECHO) "[AR] libint10.a"
	$(Q)$(AR) rc libint10.a $(LIBINT10_OBJS)

libint10.so: $(BUILD_DEPS) $(LIBINT10_OBJS)
	$(Q)$(ECHO) "[LD] libint10.so"
	$(Q)$(LD) -shared -L. $(LIBINT10_OBJS) -lsys -lc -lvm86 -nostdlib -o $@
