/* $Id: int10.h 354 2008-05-14 14:23:27Z l4check $ */
/*!
 * \file	x86emu/include/int10.h
 * \brief	console protocol definitions.
 *
 * \date	2005
 * \author	Frank Mehnert <fm3@os.inf.tu-dresden.de>
 *
 * These macros are used as parameters for the IDL functions. */

/* (c) 2005 'Technische Universitaet Dresden'
 * This file is part of the con package, which is distributed under
 * the terms of the GNU General Public License 2. Please see the
 * COPYING file for details. */


#ifndef _X86EMU_INT10_H
#define _X86EMU_INT10_H

#define EMU_MEM 1024*1024
#define EMU_PAGES EMU_MEM/PAGE_SIZE

#define VGA_BIOS_START 0xA0000
#define VGA_BIOS_END   0xD0000
#define SYS_BIOS_START 0xF0000
#define SYS_BIOS_END   0x100000

#define VGA_BIOS_LEN (VGA_BIOS_END - VGA_BIOS_START)
#define SYS_BIOS_LEN (SYS_BIOS_END - SYS_BIOS_START)

#define VGA_BIOS_PAGES VGA_BIOS_LEN/PAGE_SIZE
#define SYS_BIOS_PAGES SYS_BIOS_LEN/PAGE_SIZE

#define VGA_BIOS_PAGE VGA_BIOS_START/PAGE_SIZE
#define SYS_BIOS_PAGE SYS_BIOS_START/PAGE_SIZE
#endif
