# Makefile.mk (libvm86)
# Real mode x86 emulation library
# Originally written by MadTirra <madtirra@jarios.org>
# (c) Jari OS core development team 2005-2008
#

-include ../../config

LIBJOSCONF_OBJS += extra/libjosconf/lib/josconf.o

CFLAGS += -Iextra/libsexpr/include -Iextra/libjosconf/include

CLEAN_OBJS += $(LIBJOSCONF_OBJS)

BUILD_LIBS += libjosconf.a

BUILD_SO += libjosconf.so

libjosconf.a: $(BUILD_DEPS) $(LIBJOSCONF_OBJS)
	$(Q)$(ECHO) "[AR] libjosconf.a"
	$(Q)$(AR) rc libjosconf.a $(LIBJOSCONF_OBJS)

libjosconf.so: $(BUILD_DEPS) $(LIBJOSCONF_OBJS)
	$(Q)$(ECHO) "[LD] libjosconf.so"
	$(Q)$(LD) -shared -L. $(LIBJOSCONF_OBJS) -lsexpr -lc -nostdlib -o $@
