/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Paul Graphov <graphov@jarios.org>
 *
 * internal libpci macros for simplier function declaration
 *
 */


#define MK_READ_FUNC(type,dsize,name)                                   \
  int pci_read_config_##name(pci_dev_t *dev,                            \
                             uint16_t offset, type *val)                \
  {                                                                     \
    pci_reg_op_t rop;                                                   \
    int res;                                                            \
    rop.offset = offset;                                                \
    rop.size = dsize;                                                   \
    memcpy(&rop.addr, &dev->addr, sizeof(pci_addr_t));                  \
    res = ioctl(pcifd, PIOC_READ_REG, &rop);                            \
    if(res >= 0) {                                                      \
      *val = rop.value;                                                 \
      return 0;                                                         \
    } else {                                                            \
      return res;                                                       \
    }                                                                   \
  }

#define MK_WRITE_FUNC(type,dsize,name)                                  \
  int pci_write_config_##name(pci_dev_t *dev,                           \
                             uint16_t offset, type val)                 \
  {                                                                     \
    pci_reg_op_t rop;                                                   \
    rop.offset = offset;                                                \
    rop.size = dsize;                                                   \
    memcpy(&rop.addr, &dev->addr, sizeof(pci_addr_t));                  \
    rop.value = val;                                                    \
    return ioctl(pcifd, PIOC_WRITE_REG, &rop);                          \
  }
