# Makefile.mk (libpng)
# Port of PNG reference library
# Originally written by Graphov Paul <graphov@jarios.org>
# (c) Jari OS core development team 2005-2009
#

-include ../../config

LIBPNG_OBJS += \
	extra/libpng/src/png.o\
	extra/libpng/src/pngerror.o\
	extra/libpng/src/pnggccrd.o\
	extra/libpng/src/pngget.o\
	extra/libpng/src/pngmem.o\
	extra/libpng/src/pngpread.o\
	extra/libpng/src/pngread.o\
	extra/libpng/src/pngrio.o\
	extra/libpng/src/pngrtran.o\
	extra/libpng/src/pngrutil.o\
	extra/libpng/src/pngset.o\
	extra/libpng/src/pngtrans.o\
	extra/libpng/src/pngvcrd.o\
	extra/libpng/src/pngwio.o\
	extra/libpng/src/pngwrite.o\
	extra/libpng/src/pngwtran.o\
	extra/libpng/src/pngwutil.o

CFLAGS += -Iextra/libpng/include -DPNG_NO_WRITE_SUPPORTED

CLEAN_OBJS += $(LIBPNG_OBJS)

BUILD_LIBS += libpng.a

BUILD_SO += libpng.so

libpng.a: $(BUILD_DEPS) $(LIBPNG_OBJS)
	$(Q)$(ECHO) "[AR] libpng.a"
	$(Q)$(AR) rc libpng.a $(LIBPNG_OBJS)

libpng.so: $(BUILD_DEPS) $(LIBPNG_OBJS)
	$(Q)$(ECHO) "[LD] libpng.so"
	$(Q)$(LD) -shared -L. $(LIBPNG_OBJS) -lz -lc -nostdlib -o $@



