# Makefile.mk (libsexpr)
# Port of S-Expressions small and fast library
# Originally written by MadTirra <madtirra@jarios.org>
# (c) Jari OS core development team 2005-2009
#

-include ../../config

LIBSEXPR_OBJS += extra/libsexpr/src/cstring.o extra/libsexpr/src/event_temp.o \
	extra/libsexpr/src/faststack.o extra/libsexpr/src/io.o \
	extra/libsexpr/src/parser.o extra/libsexpr/src/sexp.o \
	extra/libsexpr/src/sexp_memory.o extra/libsexpr/src/sexp_ops.o \
	extra/libsexpr/src/sexp_vis.o

CFLAGS += -Iextra/libsexpr/include

CLEAN_OBJS += $(LIBSEXPR_OBJS)

BUILD_LIBS += libsexpr.a

BUILD_SO += libsexpr.so

libsexpr.a: $(BUILD_DEPS) $(LIBSEXPR_OBJS)
	$(Q)$(ECHO) "[AR] libsexpr.a"
	$(Q)$(AR) rc libsexpr.a $(LIBSEXPR_OBJS)

libsexpr.so: $(BUILD_DEPS) $(LIBSEXPR_OBJS)
	$(Q)$(ECHO) "[LD] libsexpr.so"
	$(Q)$(LD) -shared -L. $(LIBSEXPR_OBJS) -lc -nostdlib -o $@
