# Makefile.mk (libvm86)
# Real mode x86 emulation library
# Originally written by MadTirra <madtirra@jarios.org>
# (c) Jari OS core development team 2005-2008
#

-include ../../config

LIBVM86_OBJS += extra/libvm86/src/decode.o \
	extra/libvm86/src/fpu.o extra/libvm86/src/ops.o \
	extra/libvm86/src/ops2.o extra/libvm86/src/prim_ops.o \
	extra/libvm86/src/sys.o

CFLAGS += -Iextra/libvm86/include -Iextra/libvm86/src

CLEAN_OBJS += $(LIBVM86_OBJS)

BUILD_LIBS += libvm86.a 

BUILD_SO += libvm86.so

libvm86.a: $(BUILD_DEPS) $(LIBVM86_OBJS)
	$(Q)$(ECHO) "[AR] libvm86.a"
	$(Q)$(AR) rc libvm86.a $(LIBVM86_OBJS)

libvm86.so: $(BUILD_DEPS) $(LIBVM86_OBJS)
	$(Q)$(ECHO) "[LD] libvm86.so"
	$(Q)$(LD) -shared -L. $(LIBVM86_OBJS) -lc -nostdlib -o $@
