/*
 * Realmode X86 Emulator Library
 *
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * Copyright (C) 1996-1999 SciTech Software, Inc.
 * Copyright (C) David Mosberger-Tang
 * Copyright (C) 1999 Egbert Eich
 * Copyright (C) 2008 Jari OS core team <http://jarios.org>
 * Copyright (C) 2008 Paul Graphov <graphov@jarios.org> 
 *               (porting to Jari OS)
 *
 */

#ifndef __X86EMU_PRIM_OPS_H
#define __X86EMU_PRIM_OPS_H

#ifdef  __cplusplus
extern "C" {            			/* Use "C" linkage when in C++ mode */
#endif

uint16_t     aaa_word (uint16_t d);
uint16_t     aas_word (uint16_t d);
uint16_t     aad_word (uint16_t d);
uint16_t     aam_word (uint8_t d);
uint8_t      adc_byte (uint8_t d, uint8_t s);
uint16_t     adc_word (uint16_t d, uint16_t s);
uint32_t     adc_long (uint32_t d, uint32_t s);
uint8_t      add_byte (uint8_t d, uint8_t s);
uint16_t     add_word (uint16_t d, uint16_t s);
uint32_t     add_long (uint32_t d, uint32_t s);
uint8_t      and_byte (uint8_t d, uint8_t s);
uint16_t     and_word (uint16_t d, uint16_t s);
uint32_t     and_long (uint32_t d, uint32_t s);
uint8_t      cmp_byte (uint8_t d, uint8_t s);
uint16_t     cmp_word (uint16_t d, uint16_t s);
uint32_t     cmp_long (uint32_t d, uint32_t s);
uint8_t      daa_byte (uint8_t d);
uint8_t      das_byte (uint8_t d);
uint8_t      dec_byte (uint8_t d);
uint16_t     dec_word (uint16_t d);
uint32_t     dec_long (uint32_t d);
uint8_t      inc_byte (uint8_t d);
uint16_t     inc_word (uint16_t d);
uint32_t     inc_long (uint32_t d);
uint8_t      or_byte (uint8_t d, uint8_t s);
uint16_t     or_word (uint16_t d, uint16_t s);
uint32_t     or_long (uint32_t d, uint32_t s);
uint8_t      neg_byte (uint8_t s);
uint16_t     neg_word (uint16_t s);
uint32_t     neg_long (uint32_t s);
uint8_t      not_byte (uint8_t s);
uint16_t     not_word (uint16_t s);
uint32_t     not_long (uint32_t s);
uint8_t      rcl_byte (uint8_t d, uint8_t s);
uint16_t     rcl_word (uint16_t d, uint8_t s);
uint32_t     rcl_long (uint32_t d, uint8_t s);
uint8_t      rcr_byte (uint8_t d, uint8_t s);
uint16_t     rcr_word (uint16_t d, uint8_t s);
uint32_t     rcr_long (uint32_t d, uint8_t s);
uint8_t      rol_byte (uint8_t d, uint8_t s);
uint16_t     rol_word (uint16_t d, uint8_t s);
uint32_t     rol_long (uint32_t d, uint8_t s);
uint8_t      ror_byte (uint8_t d, uint8_t s);
uint16_t     ror_word (uint16_t d, uint8_t s);
uint32_t     ror_long (uint32_t d, uint8_t s);
uint8_t      shl_byte (uint8_t d, uint8_t s);
uint16_t     shl_word (uint16_t d, uint8_t s);
uint32_t     shl_long (uint32_t d, uint8_t s);
uint8_t      shr_byte (uint8_t d, uint8_t s);
uint16_t     shr_word (uint16_t d, uint8_t s);
uint32_t     shr_long (uint32_t d, uint8_t s);
uint8_t      sar_byte (uint8_t d, uint8_t s);
uint16_t     sar_word (uint16_t d, uint8_t s);
uint32_t     sar_long (uint32_t d, uint8_t s);
uint16_t     shld_word (uint16_t d, uint16_t fill, uint8_t s);
uint32_t     shld_long (uint32_t d, uint32_t fill, uint8_t s);
uint16_t     shrd_word (uint16_t d, uint16_t fill, uint8_t s);
uint32_t     shrd_long (uint32_t d, uint32_t fill, uint8_t s);
uint8_t      sbb_byte (uint8_t d, uint8_t s);
uint16_t     sbb_word (uint16_t d, uint16_t s);
uint32_t     sbb_long (uint32_t d, uint32_t s);
uint8_t      sub_byte (uint8_t d, uint8_t s);
uint16_t     sub_word (uint16_t d, uint16_t s);
uint32_t     sub_long (uint32_t d, uint32_t s);
void    test_byte (uint8_t d, uint8_t s);
void    test_word (uint16_t d, uint16_t s);
void    test_long (uint32_t d, uint32_t s);
uint8_t      xor_byte (uint8_t d, uint8_t s);
uint16_t     xor_word (uint16_t d, uint16_t s);
uint32_t     xor_long (uint32_t d, uint32_t s);
void    imul_byte (uint8_t s);
void    imul_word (uint16_t s);
void    imul_long (uint32_t s);
void 	imul_long_direct(uint32_t *res_lo, uint32_t* res_hi,uint32_t d, uint32_t s);
void    mul_byte (uint8_t s);
void    mul_word (uint16_t s);
void    mul_long (uint32_t s);
void    idiv_byte (uint8_t s);
void    idiv_word (uint16_t s);
void    idiv_long (uint32_t s);
void    div_byte (uint8_t s);
void    div_word (uint16_t s);
void    div_long (uint32_t s);
void    ins (int size);
void    outs (int size);
uint16_t     mem_access_word (int addr);
void    push_word (uint16_t w);
void    push_long (uint32_t w);
uint16_t     pop_word (void);
uint32_t		pop_long (void);

#ifdef  __cplusplus
}                       			/* End of "C" linkage for C++   	*/
#endif

#endif /* __X86EMU_PRIM_OPS_H */
