# Makefile.mk (libz)
# Port of zlib compression library
# Originally written by MadTirra <madtirra@jarios.org>
# (c) Jari OS core development team 2005-2009
#

-include ../../config

LIBZ_OBJS += extra/libz/src/adler32.o extra/libz/src/compress.o  extra/libz/src/crc32.o \
	extra/libz/src/gzio.o extra/libz/src/uncompr.o extra/libz/src/deflate.o \
	extra/libz/src/trees.o extra/libz/src/zutil.o extra/libz/src/inflate.o \
	extra/libz/src/infback.o extra/libz/src/inftrees.o extra/libz/src/inffast.o

CFLAGS += -Iextra/libz/include

CLEAN_OBJS += $(LIBZ_OBJS)

BUILD_LIBS += libz.a

BUILD_SO += libz.so

libz.a: $(BUILD_DEPS) $(LIBZ_OBJS)
	$(Q)$(ECHO) "[AR] libz.a"
	$(Q)$(AR) rc libz.a $(LIBZ_OBJS)

libz.so: $(BUILD_DEPS) $(LIBZ_OBJS)
	$(Q)$(ECHO) "[LD] libz.so"
	$(Q)$(LD) -shared -L. $(LIBZ_OBJS) -lc -nostdlib -o $@
