/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 MadTirra <madtirra@jarios.org>
 *
 * LibAlloc:
 * alloc/smalloc.h: Simple implementation of malloc(), free() and related functions
 *                  it's relatively simple, seems to be changed to more 
 *                  efficient allocator
 *
 */

#ifndef __SMALLOC_H__
#define __SMALLOC_H__

#include <sys/types.h>
#include <datalib/usrtc.h>

/* TODO: redesign this totally */

#define MAX_CHUNK_SIZE  1024

#define CACHES_AMOUNT   7

typedef struct __smcache_t {
  uint16_t size; /* cache size */
  usrtc_t free; /* data structure with free chunks */
  usrtc_t alloc; /* data structure with already allocated chunks */
  struct __smcache_t *next; /* pointer to the next associated cache page*/
} sm_cache_t;

typedef struct __smchunk_t {
  sm_cache_t *cache;
  usrtc_node_t node;
} sm_chunk_t;

/* functions */
void *smalloc(size_t size);
void sfree(void *p);
void *scalloc(size_t n,size_t size);

#endif /* __SMALLOC_H__ */

