/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 *
 * LibC:
 * inclide/assert.h: Diagnostics
 */

#ifndef __ASSERT_H__
#define __ASSERT_H__

//#ifdef NDEBUG

#define assert(expr) ((void) 0)

//#else

/* This prints an "Assertion failed" message and aborts. */
extern void __assert_fail(const char *assertion, const char *file,
		          unsigned int line, const char *function);


/* Version 2.4 and later of GCC define a magical variable `__PRETTY_FUNCTION__'
 * which contains the name of the function currently being defined.
 * C9x has a similar variable called __func__, but prefer the GCC one.
 */
/*
#if __GNUC_PREREQ (2, 4)
#  define __ASSERT_FUNCTION   __PRETTY_FUNCTION__
#else
#  if defined __STDC_VERSION__ && __STDC_VERSION__ >= 199901L
#    define __ASSERT_FUNCTION __func__
#  else
 */

#    define __ASSERT_FUNCTION ((const char*) 0)
/*
#   endif
#endif
*/
/*
#define assert(expr)                                                       \
  ((expr)                                                                  \
   ? ((void) 0)                                                            \
   : __assert_fail(__STRING(expr), __FILE__, __LINE__, __ASSERT_FUNCTION))
*/
//#endif  /* NDEBUG */

#endif  /* __ASSERT_H__ */
