/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2008 Jari Operating System Core dev team <http://jarios.org>
 * (c) Copyright 2005-2008 MadTirra <madtirra@jarios.org>
 *
 * LibAlloc:
 * include/datalib/tree.h: trees related usrtc functions prototypes
 *
 */ 

#ifndef __DATALIB_TREE_H__
#define __DATALIB_TREE_H__

#include <datalib/usrtc.h>

#define tree_root_priv(T) ((T)->sentinel.left)
#define tree_null_priv(L) (&(L)->sentinel)
#define TREE_DEPTH_MAX 64

/*tree functions*/
void usrtc_tree_init(usrtc_t *us);
usrtc_node_t *usrtc_tree_insert(usrtc_t *us,usrtc_node_t *node,const void *key);
void usrtc_tree_delete(usrtc_t *us,usrtc_node_t *node,usrtc_node_t **pswap,usrtc_node_t **pchild);
usrtc_node_t *usrtc_tree_lookup(usrtc_t *us,const void *key);
usrtc_node_t *usrtc_tree_lower_bound(usrtc_t *us,const void *key);
usrtc_node_t *usrtc_tree_upper_bound(usrtc_t *us,const void *key);
usrtc_node_t *usrtc_tree_first(usrtc_t *us);
usrtc_node_t *usrtc_tree_last(usrtc_t *us);
usrtc_node_t *usrtc_tree_next(usrtc_t *us, usrtc_node_t *curr);
usrtc_node_t *usrtc_tree_prev(usrtc_t *us, usrtc_node_t *curr);
void usrtc_tree_convert_to_list(usrtc_t *us);
void usrtc_tree_convert_from_list(usrtc_t *us);
void usrtc_tree_rotate_left(usrtc_node_t *child,usrtc_node_t *parent);
void usrtc_tree_rotate_right(usrtc_node_t *child,usrtc_node_t *parent);


#endif /*__DATALIB_TREE_H__*/
