/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009, Paul Graphov <graphov@jarios.org>
 *
 * 
 * 
 */

#ifndef __DEVIO_IRQIOCTL_H__
#define __DEVIO_IRQIOCTL_H__

typedef struct __irq_ctl_t {
  int cmd; // balance control cmd for IRQCON_BALANCE_CONTROL
  uint16_t flags;
  int irq;
  int cpu;
  int mask;
  int vec;
  int limit;
} irq_ctl_t;

#define IRQ_IOCTL 'I'

#define IRQIOC_ROUTE _IOW(IRQ_IOCTL, IRQCON_ROUTE, irq_ctl_t)
#define IRQIOC_MASK _IOW(IRQ_IOCTL, IRQCON_MASK, irq_ctl_t)
#define IRQIOC_SET_PRIO _IOW(IRQ_IOCTL, IRQCON_SET_PRIO, irq_ctl_t)
#define IRQIOC_BALANCE_CONTROL _IOWRFIX(IRQ_IOCTL, IRQCON_BALANCE_CONTROL, irq_ctl_t)
#define IRQIOC_ADD_LISTENER _IOW(IRQ_IOCTL, IRQCON_ADD_LISTENER, irq_ctl_t)
#define IRQIOC_RM_LISTENER _IOW(IRQ_IOCTL, IRQCON_RM_LISTENER, irq_ctl_t)
#define IRQIOC_SET_MODE _IOW(IRQ_IOCTL, IRQCON_SET_MODE, irq_ctl_t)
#endif
