/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 *
 * LibC:
 * include/dirent.h: directory operations
 *
 */

#ifndef __DIRENT_H__
#define __DIRENT_H__

struct dirent {
  ino_t d_ino;
  off_t d_off;
  unsigned short d_namlen;
  unsigned short d_rec_len;
  char d_name[256];             /* must not exceed NAME_MAX (see limits.h) */
};

/* This is the data type of directory stream objects.
 * The actual structure is opaque to users.
 */
typedef struct __dirstream DIR;

DIR* opendir(const char *pathname);
int closedir(DIR *dirp);

struct dirent* readdir(DIR *dirp);

#endif  /* __DIRENT_H__ */
