/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 MadTirra <madtirra@jarios.org>
 *
 * LibC:
 * include/ipc/iov.h: IPC channel 
 *
 */

#ifndef __IPC_IOV_H__
#define __IPC_IOV_H__

#include <sys/types.h>
#include <sys/poll.h>
#include <ipc/port.h>
#include <ipc/channel.h>
#include <time.h>

typedef struct __iovec_t {
  void *iov_base;
  size_t iov_len;
} iovec_t;

int ipc_iov_send(chid_t ch,iovec_t *snd_iov, int snd_iovn, void *rcv_msg, size_t size);
int ipc_iov_iov_send(chid_t ch,iovec_t *snd_iov, int snd_iovn, iovec_t *rcv_iov, int rcv_iovn);
int ipc_port_reply_nmsg_iov(prtid_t id, iovec_t *repl_iov, int repl_iovn, int msg_id);
int ipc_port_reply_iov(prtid_t id, iovec_t *repl_iov, int repl_iovn);
#endif /* __IPC_IOV_H__ */
