/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 MadTirra <madtirra@jarios.org>
 * (c) Copyright 2008 Dmitry Gromada <gromada@jarios.org>
 *
 * LibOS:
 * include/lock.h: locks
 *
 */

#ifndef __LOCK_H__
#define __LOCK_H__

#include <stdbool.h>
#include <sys/types.h>
#include <errno.h>
#include <arch/atomic.h>

enum {
  RW_SEM_READ,
  RW_SEM_WRITE
};

typedef struct __rw_usem {
  atomic_t count;
  bool locks[2];
} rw_usem_t;

typedef ulong_t sem_t;

/* TODO: it's a faked stuff, will be rewritten */

void sem_lock(ulong_t *lock);

void sem_unlock(ulong_t *lock);

void rw_usem_init(rw_usem_t *sem);
bool rw_usem_try_lock(rw_usem_t *sem, int dir);
void rw_usem_unlock(rw_usem_t *sem, int dir);

#endif /* __LOCK_H__ */

