/* Required for the lwIP sources/headers */

#ifndef __CC_H__
#define __CC_H__

#include <stddef.h>
#include <byteorder.h>

#define BYTE_ORDER LITTLE_ENDIAN

#define MEMP_ALIGN_SIZE(x) (x)
#define MEM_ALIGNMENT  4
#define LWIP_MEM_ALIGN(x) (x)

typedef unsigned char u8_t;
typedef signed char s8_t;

typedef unsigned short int u16_t;
typedef signed short int s16_t;

typedef unsigned int u32_t;
typedef signed int s32_t;

typedef long mem_ptr_t;

#define PACK_STRUCT_BEGIN
#define PACK_STRUCT_END
#define PACK_STRUCT_STRUCT

#define LWIP_PLATFORM_DIAG(x)
#define LWIP_PLATFORM_ASSERT(x)

typedef struct __lwip_conf {
  int cmd_threads,api_threads;
  int cmd_port,api_port;
} lwip_conf_t;

#define LWIP_PLATFORM_HTONS(x) cpu_to_be16((x))
#define LWIP_PLATFORM_NTOHS(x) be_to_cpu16((x))

#define LWIP_PLATFORM_HTONL(x) cpu_to_be32((x))
#define LWIP_PLATFORM_NTOHL(x) be_to_cpu32((x))

#endif
