#ifndef __NETWORK_H__
#define __NETWORK_H__

#include <sys/types.h>
#include <unistd.h>
#include "lwip/netif.h"
#include "lwip/init.h"

typedef struct __netif_creds {
  err_t (*init)(struct netif *nif);
  void (*in_logic)(struct netif *nif);
} netif_creds_t;

typedef struct network_host_ethops {
  int (*etherif_init_device)(struct netif *nif);
} network_host_ethops_t;

typedef struct __network_host {
  int (*register_interface)(struct netif *nif,netif_creds_t *creds);                        ;
  int (*unregister_interface)(struct netif *nif);

  /* Ethernet drivers-related operations. */
  network_host_ethops_t *eth_ops;
} network_host_t;

typedef struct __network_driver {
  int (*probe)(network_host_t *host);
} network_driver_t;

const network_host_t *get_network_host(void);

#endif
