/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 *
 * LibC:
 * include/pwd.h: passwd access and control
 */

#ifndef __PWD_H__
#define __PWD_H__

#include <stddef.h>

#ifndef __UID_T_DEFINED
typedef unsigned short  uid_t;
#define __UID_T_DEFINED
#endif

#ifndef __GID_T_DEFINED
typedef unsigned short  gid_t;
#define __GID_T_DEFINED
#endif

struct passwd {
  char *pw_name;
  uid_t pw_uid;
  gid_t pw_gid;
  char *pw_dir;
  char *pw_shell;
};

struct passwd* getpwnam(const char *name);
struct passwd* getpwuid(uid_t uid);

int getpwnam_r(const char *name, struct passwd *pwd, char *buffer,
                size_t bufsize, struct passwd **result);
int getpwuid_r(uid_t uid, struct passwd *pwd, char *buffer,
                size_t bufsize, struct passwd **result);

void setpwent(void);
struct passwd* getpwent(void);
void endpwent(void);

#endif  /* __PWD_H__ */
