/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 *
 * LibC:
 * include/setjmp.h: Declare the macros setjmp and longjmp, which are used for
 *                   non-local exits.
 */

#ifndef __SETJMP_H__
#define __SETJMP_H__

#include <arch/setjmp.h>

/* Store the calling environment in 'env', also saving the signal mask.
 * Return 0.
 */
extern int setjmp(jmp_buf env);

/* Jump to the environment saved in 'env', making the 'setjmp' call there return
 * 'val', or 1 if 'val' is 0.
 */
extern void longjmp(jmp_buf env, int val);

#endif /* __SETJMP_H__ */
