/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 MadTirra <madtirra@jarios.org>
 * (c) Copyright 2008 Paul Graphov <graphov@jarios.org>
 *
 * LibOS:
 * sys/ioport.h: IO ports related functions
 *
 */

#ifndef __SYS_IOPORT_H__
#define __SYS_IOPORT_H__

#include <sys/types.h>

/* TODO: doc, in out implementation */

/* allocate ports from sport to sport+amount*/
status_t alloc_ioport_range(ulong_t sport,ulong_t amount);

/* the same just freed */
status_t free_ioport_range(ulong_t sport,ulong_t amount);

/* io ports functions */
/* read byte value from io port */
extern inline uint8_t inb(uint16_t port);

/* put byte value to io port */
extern inline void outb(uint16_t port,uint8_t vl);

/* read 16 bit value from io port */
extern inline uint16_t inw(uint16_t port);

/* put 16 bit value to io port */
extern inline void outw(uint16_t port,uint16_t vl);

/* read 32 bit value from io port */
extern inline uint32_t inl(uint16_t port);

/* put 32 bit value to io port */
extern inline void outl(uint16_t port,uint32_t vl);

#endif /* __SYS_IOPORT_H__ */

