/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2005,2008 MadTirra <madtirra@jarios.org> 
 *
 * mount call
 * 
 */

#ifndef __SYS_MOUNT_H__
#define __SYS_MOUNT_H__

#define MS_BIND         (1 << 0)
#define MS_DIRSYNC      (1 << 1)
#define MS_MANDLOCK     (1 << 2)
#define MS_MOVE         (1 << 3)
#define MS_NOATIME      (1 << 4)
#define MS_NODEV        (1 << 5)
#define MS_NODIRATIME   (1 << 6)
#define MS_NOEXEC       (1 << 7)
#define MS_NOSUID       (1 << 8)
#define MS_RDONLY       (1 << 9)
#define MS_RELATIME     (1 << 10)
#define MS_REMOUNT      (1 << 12)
#define MS_SYNCHRONOUS  (1 << 13)

/*
 * mount_s(), mount_w():
 * mounts device, file or special file system.
 * dev - device, file, special path, special file system id
 * point - directory to mount on
 * return 0 if all is ok, or -1 if something happend
 * mount_s takes ASCII as input
 * mount_w takes Unicode as input
 */
int mount_s(const char *dev,const char *point,char *fstype,int flags);
int mount_w(const wchar_t *dev,const wchar_t *point,char *fstype,int flags);

#define mount(a,b,c)  mount_s(a,b,c)

#endif /* __SYS_MOUNT_H__ */
