#ifndef __PROCMGR_H__
#define __PROCMGR_H__

#include <sys/types.h>
#include <limits.h>

#define PROCMGR_NAME "procmgr.x"
#define PROCMGR_CLIENT_PORT_NAME "client_port"

#define __PROCMGR_CMD_FORK          0
#define __PROCMGR_CMD_EXEC          1
#define __PROCMGR_CMD_LOAD_LIBRARY  2

typedef struct __pm_fork_request {
  pid_t child_pid;
} pm_fork_request_t;

#define PM_ARGV_SIZE  (PATH_MAX)
#define PM_ENVP_SIZE  (PATH_MAX)

typedef struct __pm_exec_request {
  char args[PATH_MAX+PM_ARGV_SIZE];
  int numargs,argsize;
  uint16_t arg_offsets[ARG_MAX];
} pm_exec_request_t;

typedef struct __pm_loadlib_request {
  char filename[PATH_MAX];
} pm_loadlib_request_t;

typedef struct __pm_cmd_header {
  int cmd;
} pm_cmd_header_t;

#endif
