/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 Michael Tsymbalyuk <mtzaurus@gmail.com>
 *
 * LibOS:
 * include/sys/ptd.h: per-task userspace data structure.
 *
 */

#ifndef __SYS_PTD_H__
#define  __SYS_PTD_H__

#include <sys/types.h>
#include <arch/ptd.h>

#define PTD_CUSTOM_SLOTS  8  /* Per-task private slots. */

typedef struct __process_global_data {
  void *unused;
} process_global_data_t;

typedef struct __thread_local_data {
  void *unused;
} thread_local_data_t;

typedef struct __per_task_data {
  uintptr_t ptd_base;
  int _errno;
  process_global_data_t *process_global_data;
  thread_local_data_t *task_private_data;
  ulong_t custom_slots[PTD_CUSTOM_SLOTS];
} per_task_data_t;

#endif  /* __SYS_PTD_H__ */
