/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Michael Tsymbalyuk <mtzaurus@gmail.com>
 *
 * LibC:
 * include/sys/swks.h: SWKS support.
 */

#ifndef __SWKS_H__
#define __SWKS_H__

#include <sys/types.h>

/* System-Wide Kernel Statistics. */
typedef struct __swks {
  /* Mandatory statistics. */
  ulong_t  system_clock_ticks;
  ulong_t  hz,secs_since_epoch;

  /* Later some fields will be added here. */
} swks_t;

swks_t *get_swks(void);
uint64_t current_sys_ticks(swks_t *swks);

static inline uint32_t msec_to_ticks(swks_t *swks, uint16_t ms)
{
  uint32_t ret;

  ret = (uint32_t)ms * swks->hz / 1000;

  return ret ? ret : 1;
}

static inline uint32_t ticks_to_msec(swks_t *swks, uint16_t ticks)
{
  uint32_t ret;

  ret = ticks * 1000 / swks->hz;

  return ret ? ret : 1;
}

#endif
