/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 *
 * LibC:
 * include/sys/time.h: POSIX time and date functions and structures
 */

#ifndef __SYS_TIME_H__
#define __SYS_TIME_H__

#include <arch/wordsize.h>

#ifndef __TIME_T_DEFINED
#if BITS_PER_LONG == 64
typedef long time_t;
#define __TIME_T_DEFINED 1
#endif
#endif

#ifndef __SUSECONDS_T_DEFINED
typedef long suseconds_t;
#define __SUSECONDS_T_DEFINED 1
#endif

struct timeval {
  time_t      tv_sec;           /* seconds */
  suseconds_t tv_usec;          /* microseconds */
};

struct itimerval {
  struct timeval it_interval;
  struct timeval it_value;
};

int gettimeofday(struct timeval *tp, void *tzp);

#endif  /* __SYS_TIME_H__ */
