/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 Michael Tsymbalyuk <mtzaurus@gmail.com>
 *
 * sys/uevent.h: Data types and function prototypes for dealing with
 *               low-level kernel events.
 */

#ifndef __SYS_UEVENT_H__
#define  __SYS_UEVENT_H__

#include <sys/types.h>

#define __SO_RAWEVENT 3  /** Kernel event object **/

typedef struct __event {
  __sync_id_t __id;
} event_t;

enum {
  __SYNC_CMD_EVENT_WAIT=0x200,    /**< Wait for target event to arrive. **/
  __SYNC_CMD_EVENT_SIGNAL=0x201,  /**< Signal target event. **/
};

status_t event_init(event_t *e);
status_t event_destroy(event_t *e);
status_t event_wait(event_t *e);
status_t event_signal(event_t *e);

#endif
