/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 *
 * LibC:
 * include/tar.h: Magic numbers for the tar archive format
 */

#ifndef __TAR_H__
#define __TAR_H__

#define TMAGIC         "ustar"         /* 'ustar' and '\0' */
#define TMAGLEN        6
#define TVERSION       "00"
#define TVERSLEN       2

enum tar_mode {
  TSUID   = 04000,
  TSGID   = 02000,
  TSVTX   = 01000,
  TUREAD  = 00400,
  TUWRITE = 00200,
  TUEXEC  = 00100,
  TGREAD  = 00040,
  TGWRITE = 00020,
  TGEXEC  = 00010,
  TOREAD  = 00004,
  TOWRITE = 00002,
  TOEXEC  = 00001
};

enum tar_link_type {
  REGTYPE  = '0',                      /* Regular file (preferred code) */
  AREGTYPE = '\0',                     /* Regular file (alternate code) */
  LNKTYPE  = '1',                      /* Hard link */
  SYMTYPE  = '2',                      /* Symbolic link (hard if not supported) */
  CHRTYPE  = '3',                      /* Character special */
  BLKTYPE  = '4',                      /* Block special */
  DIRTYPE  = '5',                      /* Directory */
  FIFOTYPE = '6',                      /* Named pipe */
  CONTTYPE = '7'                       /* Contiguous file */
  /* regular file if not supported */
};

#endif  /* __TAR_H__ */
