/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 *
 * LibC:
 * include/utime.h: inode access and modification times
 */

#ifndef __UTIME_H__
#define __UTIME_H__

#include <arch/wordsize.h>

#ifndef __TIME_T_DEFINED
#if BITS_PER_LONG == 64
typedef long time_t;
#define __TIME_T_DEFINED 1
#endif
#endif

struct utimbuf {
  time_t actime;
  time_t modtime;
};

int utime(const char *path, const struct utimbuf *times);

#endif  /* __UTIME_H__ */
