/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 MadTirra <madtirra@jarios.org>
 *
 * LibC:
 * include/wctype.h: wide char related functions
 */

#ifndef __WCTYPE_H__
#define __WCTYPE_H__

#ifndef __WINT_T_DEFINED
typedef __WCHAR_TYPE__   wint_t;
#define __WINT_T_DEFINED 1
#endif

wint_t towlower(wint_t c);
wint_t towupper(wint_t c);

int iswalpha(wint_t c);
int iswdigit(wint_t c);
int iswalphanum(wint_t c);
int iswblank(wint_t c);
int iswcntrl(wint_t c);
int iswprint(wint_t c);
int iswpunct(wint_t c);
int iswspace(wint_t c);
int iswgraph(wint_t c);
int iswxdigit(wint_t c);
int iswlower(wint_t c);
int iswupper(wint_t c);

#endif  /* __WCTYPE_H__ */
