# Makefile.mk (libc)
# libc for Jari Operating System includes all general entries
# and linking stuff
# Originally written by MadTirra <madtirra@jarios.org>
# (c) Jari OS core development team 2005-2008
#

-include ../../config

ifeq ($(ARCH),amd64)
LIBC_OBJS = general/libc/mach/amd64/jump.o	\
	general/libc/mach/amd64/memcpy.o	\
	general/libc/mach/amd64/memmove.o	\
	general/libc/mach/amd64/memset.o	\
	general/libc/mach/amd64/strcpy.o	\
	general/libc/mach/amd64/strlen.o	\
	general/libc/mach/amd64/syscall.o

LD_ENTRY = general/libc/mach/amd64/entry.S
LD_ENTRY_OBJ = $(LD_ENTRY:.S=.o)

LDUS = general/libc/mach/amd64/elf_amd64_jarios.ld.S

INSTALL_OBJS += $(LD_ENTRY_OBJ)

endif

LIBC_OBJS += general/libc/getgid.o		\
	general/libc/getopt.o			\
	general/libc/getuid.o			\
	general/libc/setgid.o			\
	general/libc/setuid.o			\
	general/libc/strerror.o			\
		\
	general/libc/alloc/dlmalloc.o		\
	general/libc/alloc/weak_mutex.o		\
		\
	general/libc/ipc/__channel.o		\
	general/libc/ipc/__iov.o		\
	general/libc/ipc/__port.o		\
	general/libc/ipc/channel.o		\
	general/libc/ipc/iov.o			\
	general/libc/ipc/ippq.o			\
	general/libc/ipc/port.o			\
	general/libc/ipc/unirpc.o		\
		\
	general/libc/jarifs/__fildesc.o		\
	general/libc/jarifs/__init.o		\
	general/libc/jarifs/__iovpath.o		\
	general/libc/jarifs/__pidfd.o		\
	general/libc/jarifs/access.o		\
	general/libc/jarifs/chdir.o		\
	general/libc/jarifs/chmod.o		\
	general/libc/jarifs/chown.o		\
	general/libc/jarifs/close.o		\
	general/libc/jarifs/closedir.o		\
	general/libc/jarifs/creat.o		\
	general/libc/jarifs/deviofs_ioctl.o	\
	general/libc/jarifs/dup.o		\
	general/libc/jarifs/fcntl.o		\
	general/libc/jarifs/ftruncate.o		\
	general/libc/jarifs/getcwd.o		\
	general/libc/jarifs/getfpid.o		\
	general/libc/jarifs/getufsid.o		\
	general/libc/jarifs/ioctl.o		\
	general/libc/jarifs/lseek.o		\
	general/libc/jarifs/mkdir.o		\
	general/libc/jarifs/open.o		\
	general/libc/jarifs/opendir.o		\
	general/libc/jarifs/pread.o		\
	general/libc/jarifs/pwrite.o		\
	general/libc/jarifs/read.o		\
	general/libc/jarifs/readdir.o		\
	general/libc/jarifs/readlink.o		\
	general/libc/jarifs/remove.o	\
	general/libc/jarifs/rmdir.o		\
	general/libc/jarifs/stat.o		\
	general/libc/jarifs/sync.o		\
	general/libc/jarifs/truncate.o		\
	general/libc/jarifs/umask.o		\
	general/libc/jarifs/unlink.o		\
	general/libc/jarifs/write.o		\
		\
	general/libc/lock/lock.o		\
		\
	general/libc/ns/ns.o			\
		\
	general/libc/passwd/__passwd.o		\
	general/libc/passwd/pwent.o		\
	general/libc/passwd/pwnam.o		\
	general/libc/passwd/pwuid.o		\
		\
	general/libc/proc/__procmgr.o		\
	general/libc/proc/fork.o		\
	general/libc/proc/exec.o		\
	general/libc/proc/waitpid.o		\
		\
	general/libc/regex/regcomp.o		\
	general/libc/regex/regerror.o		\
	general/libc/regex/regexec.o		\
	general/libc/regex/regfree.o		\
		\
	general/libc/sched/sched.o		\
		\
	general/libc/signal/signal.o		\
		\
	general/libc/stdio/printf.o		\
	general/libc/stdio/vprintf.o		\
	general/libc/stdio/vsnprintf.o		\
	general/libc/stdio/vswprintf.o		\
	general/libc/stdio/wprintf.o		\
		\
	general/libc/stdlib/bitwise.o		\
	general/libc/stdlib/environ.o		\
	general/libc/stdlib/exit.o		\
	general/libc/stdlib/perror.o		\
	general/libc/stdlib/stdlib.o		\
	general/libc/stdlib/strtoimax.o		\
	general/libc/stdlib/strtol.o		\
	general/libc/stdlib/strtod.o    \
	general/libc/stdlib/strtof.o    \
	general/libc/stdlib/strtold.o    \
	general/libc/stdlib/system.o	\
	general/libc/stdlib/__strtofpmax.o    \
	general/libc/stdlib/__fp_range_check.o    \
		\
	general/libc/streamio/__stream.o	\
	general/libc/streamio/fclose.o		\
	general/libc/streamio/ferror.o		\
	general/libc/streamio/fflush.o		\
	general/libc/streamio/fgetc.o		\
	general/libc/streamio/fgets.o		\
	general/libc/streamio/fileno.o		\
	general/libc/streamio/fopen.o		\
	general/libc/streamio/fputc.o		\
	general/libc/streamio/fputs.o		\
	general/libc/streamio/fread.o		\
	general/libc/streamio/fwrite.o		\
	general/libc/streamio/ungetc.o		\
	general/libc/streamio/ftell.o		\
	general/libc/streamio/fseek.o		\
		\
	general/libc/sys/devio.o		\
	general/libc/sys/fslinker.o		\
	general/libc/sys/kcontrol.o		\
	general/libc/sys/mmap.o			\
	general/libc/sys/misc.o			\
	general/libc/sys/proc.o			\
	general/libc/sys/queue.o		\
	general/libc/sys/routine.o		\
	general/libc/sys/scheduler.o		\
	general/libc/sys/thread.o		\
	general/libc/sys/uevent.o		\
		\
	general/libc/termios/isatty.o		\
	general/libc/termios/tcgetsetattr.o	\
		\
	general/libc/time/conv.o		\
	general/libc/time/gettime.o		\
	general/libc/time/sleep.o		\
	general/libc/time/timer.o		\
		\
	general/libc/uds/avl.o			\
	general/libc/uds/circular.o		\
	general/libc/uds/lslist.o		\
	general/libc/uds/redblack.o		\
	general/libc/uds/splay.o		\
	general/libc/uds/tree.o			\
	general/libc/uds/usrtc.o		\
		\
	general/libc/unicode/mbtowc.o		\
	general/libc/unicode/towcs.o		\
	general/libc/unicode/wctomb.o		\
	general/libc/unicode/wmemxxx.o		\
		\
	general/libc/xstring/string.o		\
	general/libc/xstring/wchar.o		\
		\
	general/libc/xtype/ctype.o		\
	general/libc/xtype/wctype.o    \
		\
	general/libc/search/hcreate_r.o    \
	general/libc/search/hdestroy_r.o    \
	general/libc/search/hsearch.o    \
	general/libc/search/hsearch_r.o    \
	general/libc/search/insque.o    \
	general/libc/search/lfind.o    \
	general/libc/search/lsearch.o    \
	general/libc/search/tdelete.o    \
	general/libc/search/tdestroy.o    \
	general/libc/search/tfind.o    \
	general/libc/search/tsearch.o    \
	general/libc/search/twalk.o

CLEAN_OBJS += $(LIBC_OBJS) ejo.ld $(LD_ENTRY_OBJ)

BUILD_LIBS += libc.a ejo.ld

BUILD_DEPS += symlibc

BUILD_SO += libc.so

libc.a: $(BUILD_DEPS) ejo.ld $(LIBC_OBJS)
	$(Q)$(ECHO) "[AR] libc.a"
	$(Q)$(AR) rc libc.a $(LIBC_OBJS)

libc.so: $(BUILD_DEPS) $(LIBC_OBJS)
	$(Q)$(ECHO) "[LD] libc.so"
	$(Q)$(CC) -shared $(LIBC_OBJS) -nostdlib -o $@

$(LD_ENTRY_OBJ): $(LD_ENTRY)
	$(Q)$(ECHO) "[AS] $(LD_ENTRY)"
	$(Q)$(CC) -c $(CFLAGS) -o $@ $<

ejo.ld: $(LDUS) $(LD_ENTRY_OBJ)
	$(Q)$(ECHO) "[PS] $(LDUS)"
	$(Q)$(CC) $(CFLAGS) -DARCH=$(ARCH) -DHOST_PREFIX=$(HOST_PREFIX)/jos/lib/jarios/libc -D__ASM__ -E -x c $(LDUS) | $(GREP) -v "^\#" > $@

symlibc: general/libc/mach/$(ARCH)
	$(Q)$(ECHO) "[LN] Prepairing links ..."
	$(Q)$(LN) -snf mach/$(ARCH) general/include/arch
