/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 MadTirra <madtirra@jarios.org>
 *
 * LibC:
 * __channel.c: low level channel operations
 *
 */

#include <sys/types.h>
#include <sys/syscall.h>
#include <errno.h>
#include <time.h>

#include <ipc/port.h>

status_t __open_ipc_channel(pid_t pid,ulong_t port,ulong_t flags)
{
  return __syscall3(SC_OPEN_CHANNEL,pid,port,flags);
}

status_t __close_ipc_channel(ulong_t channel)
{
  return __syscall1(SC_CLOSE_CHANNEL,channel);
}

status_t __msgsnd_ipc_channel(ulong_t channel,void *send_buf,
			      size_t send_size,void *rcv_buf,
			      size_t rcv_size)
{
  return __syscall5(SC_PORT_SEND,channel,(syscall_arg_t)send_buf,
		    send_size,(syscall_arg_t)rcv_buf,rcv_size);
}

status_t __evtsnd_ipc_channel(ulong_t channel,void *send_buf,
			      size_t send_size)
{
  return __syscall5(SC_PORT_SEND,channel,(syscall_arg_t)send_buf,
		    send_size,0,0);
}

