/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 MadTirra <madtirra@jarios.org>
 *
 * LibC:
 * __iov.c: low level iov channel operations
 *
 */

#include <sys/types.h>
#include <sys/syscall.h>
#include <errno.h>
#include <time.h>

#include <ipc/port.h>
#include <ipc/channel.h>
#include <ipc/iov.h>

unsigned int __ipc_channel_send_iov(chid_t channel,iovec_t *snd_vecs, int snd_nvec,
				    void *rcvmsg, size_t size)
{
  return __syscall5(SC_PORT_SEND_IOV,channel,(syscall_arg_t)snd_vecs,snd_nvec,
		    (syscall_arg_t)rcvmsg, size);
}

unsigned int __ipc_channel_send_iov_iov(chid_t channel,iovec_t *snd_vecs, int snd_nvec,
                                        iovec_t *rcv_vecs, int rcv_nvec)
{
  return __syscall5(SC_PORT_SEND_IOV_V,channel,(syscall_arg_t)snd_vecs,snd_nvec,
		    (syscall_arg_t)rcv_vecs, rcv_nvec);
}

unsigned int __reply_ipc_port_iov(ulong_t port, ulong_t msg_id, iovec_t *repl_iov,
                                  ulong_t repl_nvec)
  
{
  return __syscall4(SC_PORT_REPLY_IOV, port, msg_id, (syscall_arg_t)repl_iov, repl_nvec);
}
