/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 MadTirra <madtirra@jarios.org>
 *
 * LibC:
 * port.c: higher level port operations
 *
 */

#include <sys/types.h>
#include <sys/syscall.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <time.h>

#include <ipc/port.h>
#include <ipc/channel.h>

#include "__lowlevel.h"

chid_t ipc_channel_open(pid_t pid,prtid_t port,ulong_t flags)
{
  chid_t id;

  id=__open_ipc_channel(pid,port,flags);

  return id;
}

int ipc_channel_close(chid_t id)
{
  int rid=0;
  
  rid=__close_ipc_channel(id);
  
  return rid;
}

int ipc_channel_msgsnd(chid_t id,size_t msg_size,void *msg,
		       size_t rcv_size,void *rcvmsg)
{
  if(!msg_size)
    return -EINVAL;

  return __msgsnd_ipc_channel(id,msg,msg_size,rcvmsg,rcv_size);
}

int ipc_channel_evtsnd(chid_t id,size_t msg_size,void *msg)
{
  if(!msg_size)
    return -EINVAL;

  return __evtsnd_ipc_channel(id,msg,msg_size);
}
