/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 MadTirra <madtirra@jarios.org>
 *
 * LibC:
 * unirpc.c: RPC channels operations
 *
 */

#include <sys/types.h>
#include <sys/syscall.h>
#include <errno.h>
#include <time.h>

#include <ipc/port.h>
#include <ipc/channel.h>
#include <ipc/iov.h>
#include <ipc/rpc.h>

void *unirpc_send(chid_t ch,uni_rpc_t rpc,
		  size_t msg_size,void *msg,
		  size_t rlen,void *rmsg)
{
  int r;
  iovec_t ovec[2], ivec;

  ovec[0].iov_base=&rpc;
  ovec[0].iov_len=sizeof(rpc);
  ovec[1].iov_base=msg;
  ovec[1].iov_len=msg_size;
  ivec.iov_base = rmsg;
  ivec.iov_len = rlen;

  r=ipc_iov_send(ch,ovec,2,&ivec,1);

  return rmsg;
}

