/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Copyright (C) 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * Copyright (C) 2009 Dmitry Balakshin <balakshin@jarios.org>
 * Copyright (C) 2009 Alfeiks Kaanoken (MadTirra) <madtirra@jarios.org>
 *
 */

#ifndef __JARIFS_FILEDESC_H__
#define __JARIFS_FILEDESC_H__

typedef struct __filedesc_t {
  off_t offset;
  pid_t pid;                    /* user_link_t.pid */
  int port_id;                  /* user_link_t.port_id */
  int ufsid;                    /* user_link_t.ufsid */
  int chid;
  char *dir;			/* directory name for fchdir() */
} fds_t;

extern fds_t tfds[OPEN_MAX];

int take_fd(void);
void release_fd(int fd);

int take_exact_fd(int fd);

/**
 * @fn take_ae_fd(int fd)
 * @brief Take first free descriptor above-or-equal to fd.
 * @desc Take a new file descriptor which shall be the lowest numbered
 * available (that is, not already  open) file descriptor greater than
 * or equal to the fd.
 * @ret fd or -1 (error code EMFILE)
 */
int take_ae_fd(int fd);

/**
 * @fn valid_fd(int fd)
 * @desc Check file descriptor valid
 * @ret true - all is ok, false - EBADF
 */
int valid_fd(int fd);

#endif  /* __JARIFS_FILEDESC_H__ */
