/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Dmitry Balakshin <balakshin@jarios.org>
 *
 */

#include <limits.h>
#include <sys/types.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>

#include "__fildesc.h"

int dup(int fildes)
{
  if (!valid_fd(fildes)) {
    errno = EBADF;
    return -1;
  }

  return fcntl(fildes, F_DUPFD, 0);
}

int dup2(int fildes, int fildes2)
{
  if (!valid_fd(fildes)) {
    errno = EBADF;
    return -1;
  }

  if (!valid_fd(fildes2)) {
    errno = EBADF;
    return -1;
  }

  if (fildes == fildes2)
    return fildes2;

  close(fildes2);
  return fcntl(fildes, F_DUPFD, fildes2);
}
