/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006-2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Dmitry Balakshin <balakshin@jarios.org>
 *
 */

#include <limits.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>

#include <sys/v2.h>

#include "__fildesc.h"
#include "__dirstream.h"

DIR *opendir(const char *dirname)
{
  struct __dirstream *dirp = NULL;
  int rc;

  if ((dirname == NULL) || (dirname[0] == '\0')) {
    errno = ENOENT;
    return NULL;
  }

  dirp = malloc(sizeof(struct __dirstream));
  if (dirp == NULL)
    return NULL;
  memset(&(dirp->dd_dir), 0, sizeof(struct dirent));
  dirp->buf_limit = 0;
  dirp->buf_n = 0;
  dirp->more = 1;

  dirp->fd = open(dirname, O_RDONLY | O_DIRECTORY, 0);
  if (dirp->fd < 0) {
    rc = errno;
    free(dirp);
    errno = rc;
    return NULL;
  }

  return dirp;
}
