/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006-2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Dmitry Balakshin <balakshin@jarios.org>
 *
 */

#include <sys/types.h>
#include <errno.h>

#include <ipc/rpc.h>
#include <ipc/channel.h>

#include "__init.h"

void sync(void)
{
  uni_rpc_t rpc;
  int r;

  rpc.rpc_call = RPC_SYNC;

  r = ipc_channel_msgsnd(vfs_channel, sizeof(uni_rpc_t), &rpc,
          sizeof(uni_rpc_t), &rpc);

  errno = 0;
  if (r < 0)
    errno = -r;
  if (rpc.rpc_call != 0)
    errno = rpc.rpc_call;
}
