/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 MadTirra <madtirra@jarios.org>
 *
 * LibOS:
 * lib/lock.c: locks
 *
 */

#include <sys/types.h>
#include <sys/syscall.h>
#include <errno.h>
#include <lock/lock.h>
#include <string.h>

/* TODO: it's a faked stuff, will be rewritten */

void sem_lock(ulong_t *lock)
{
  ulong_t _lock=*lock;

  while(_lock!=0) {
    /*dummy*/
  }

  _lock++;

  *lock=_lock;

  return;
}

void sem_unlock(ulong_t *lock)
{
  ulong_t _lock=*lock;

  _lock--;;

  *lock=_lock;

  return;
}

void rw_usem_init(rw_usem_t *sem)
{
  memset(sem, 0, sizeof(rw_usem_t));
}

bool rw_usem_try_lock(rw_usem_t *sem, int dir)
{
  sem->locks[dir] = true;
  if (sem->locks[1 - dir]) {
    sem->locks[dir] = false;
    return false;
  }
  atomic_inc(&sem->count);
  if ((dir == RW_SEM_WRITE) && (sem->count > 1)) {
    if (atomic_dec_and_test(&sem->count)) {
      sem->locks[dir] = false;
    }
    return false;
  }

  return true;
}

void rw_usem_unlock(rw_usem_t *sem, int dir)
{
  if (atomic_dec_and_test(&sem->count))
    sem->locks[dir] = false;
}

