/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2007 Jari OS core team <http://jarios.org>
 *
 */

#include <sys/mman.h>

OUTPUT_FORMAT("elf64-x86-64","elf64-x86-64","elf64-x86-64")
OUTPUT_ARCH(i386:x86-64)
STARTUP(HOST_PREFIX/entry.o)
ENTRY(__entry_point)

SECTIONS {
	 /* Read only sections merged into text segment */
	 . = USER_START_VIRT;
	 .init : {
	       *(.init);
	 }
	 .text : {
	       *(.text);
	 }
	 .rodata : {
	 	 *(.rodata);
	 }
         /* align all after read only */
         . = ALIGN(PAGE_SIZE);
         /* eh_frame */
         .eh_frame ALIGN(PAGE_SIZE) : {
                   *(.eh_frame);
         }
         /* align this */
         . = ALIGN(PAGE_SIZE);
         /* dynamic sections */
         .dynamic ALIGN(PAGE_SIZE) : {
                  *(.dynamic);
         }

	 /* data and bss sections, bss follow after data section */
	 /* bss section aligned to page in case bss not present on image and should be allocated */
	 .data ALIGN(PAGE_SIZE) : {
	       *(.data);
	 }
	 .bss ALIGN(PAGE_SIZE) : {
	      *(.bss);
	      *(COMMON)
	      __heap = . ; 
	 }

	 /* __heap value , used to know in task, where code and data ends, to make */
	 /* heap and allocate pages for it */
/*	 . = ALIGN(PAGE_SIZE);
	 __heap = . ;*/

}

/*end of linker script */
