/* This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * Copyright (C)2009 Dmitry Balakshin <balakshin@jarios.org>
 *
 * LibC:
 * general/libc/passwd/__passwd.h
 */

#ifndef __LIBC_PASSWD_PASSWD_H__
#define __LIBC_PASSWD_PASSWD_H__

#define PASSWD_FILE "/etc/passwd"

extern FILE *__passwd_file;

struct buffer {
  char *buf;
  size_t size;
  size_t ofs;
};

struct passwd* __alloc_passwd(void);
void __free_passwd(struct passwd *p);

char* __strdup(const char *str, struct buffer *membuf);
int __parse_pwent(char *str, struct passwd *pwd, struct buffer *membuf);

#endif  /* __LIBC_PASSWD_PASSWD_H__ */
