/* This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * Copyright (C) 2009 Michael Tsymbalyuk <mtzaurus@gmail.com>
 * Copyright (C) 2009 Dmitry Balakshin <balakshin@jarios.org>
 *
 * libc:
 *   general/libc/proc/__procmgr.c
 *
 * Internal functions related to process manager intercommunication.
 */

#include <ns/ns.h>
#include <ipc/channel.h>
#include <sys/procmgr.h>

#include "__procmgr.h"

chid_t __proc_mgr_chid = (chid_t)-1;

void open_pm_connection(void)
{
  pid_t pm_pid;
  int p;

  if (__proc_mgr_chid == (chid_t)-1) {
    pm_pid = ns_getprocpid();

    if (pm_pid > 0) {
      p = ns_lookup_portid(pm_pid, PROCMGR_CLIENT_PORT_NAME);
      if (p >= 0)
        __proc_mgr_chid = ipc_channel_open(pm_pid, p, IPC_BLOCKED_ACCESS);
    }
  }
}
