/* This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * Copyright (C) 2009 Michael Tsymbalyuk <mtzaurus@gmail.com>
 * Copyright (C) 2009 Dmitry Balakshin <balakshin@jarios.org>
 *
 * libc:
 *   general/libc/proc/waitpid.c
 *
 * waitpid() function
 */

#include <sys/types.h>
#include <errno.h>
#include <sys/wait.h>

#include <sys/syscall.h>

pid_t waitpid(pid_t pid, int *stat_loc, int options)
{
  int rc;

  rc = __syscall3(SC_WAITPID, pid, (syscall_arg_t)stat_loc,
          (syscall_arg_t)options);
  if (rc < 0) {
    errno = -rc;
    rc = -1;
  }

  return rc;
}
