/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 *
 * Copyright (c) 1992, 1993, 1994 Henry Spencer.
 * Copyright (c) 1992, 1993, 1994
 *	The Regents of the University of California.  All rights reserved.
 *
 * This code is derived from software contributed to Berkeley by
 * Henry Spencer.
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2005,2008 MadTirra <madtirra@jarios.org> (ported to mlibc)
 *
 */

typedef enum {CALNUM, CALPHA, CBLANK, CCNTRL, CDIGIT, CGRAPH,
	      CLOWER, CPRINT, CPUNCT, CSPACE, CUPPER, CXDIGIT} citype;

/* character-class table */
static struct cclass {
	char *name;
	citype fidx;
} cclasses[] = {
	{"alnum",       CALNUM},
	{"alpha",       CALPHA},
	{"blank",       CBLANK},
	{"cntrl",       CCNTRL},
	{"digit",       CDIGIT},
	{"graph",       CGRAPH},
	{"lower",       CLOWER},
	{"print",       CPRINT},
	{"punct",       CPUNCT},
	{"space",       CSPACE},
	{"upper",       CUPPER},
	{"xdigit",      CXDIGIT},
	{NULL,          }
};
