/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 *
 * general/libc/printf-fmt.h: printf-like internal format flags
 *
 */

#ifndef __PRINTF_FMT_H__
#define __PRINTF_FMT_H__

/* type of data, that will be printed (0 - 2 bits) */
#define FMT_TNUM    0x00001 /* number */
#define FMT_TSTR    0x00002 /* string */
#define FMT_TCHAR   0x00004 /* character */
/* flags */
#define FMT_FLJ     0x00008 /* '-' flag. it means, that output will be left-justigfird */
#define FMT_FZERO   0x00010 /* zero flag */
#define FMT_FSIG    0x00020 /* signed digit or just '+' flag */
#define FMT_FSPACE  0x00040 /* if first simbol of format sequince is not digit, print space. if + and space are enable, use + */
#define FMT_FPREF   0x00080 /* prefix before digit (x, X, o only) */
/* dot, just dot */
#define FMT_DOT     0x00100
/* length modifiers */
#define FMT_LCHAR   0x00200
#define FMT_LSHORT  0x00400
#define FMT_LLONG   0x00800
#define FMT_LDLONG  0x01000
#define FMT_LSIZET  0x02000
/* extension flags for digit type */
#define FMT_DOCT    0x04000 /* octal digit */
#define FMT_DDEC    0x08000 /* decimal digit */
#define FMT_DHEX    0x10000 /* hexadecimal digit */
#define FMT_DHEX_UP 0x20000 /* hexadecimal in upper case */
#define FMT_DUNSIG  0x40000 /* unsigned digit */

/* some format masks */
#define FMT_FMASK   0x00F8 /* mask for flags */
#define FMT_LMASK   0x3E00 /* mask for length modifiers */

#define FMT_DBUF_SIZE   64  /* length buffer for temprary digits holding */

#endif  /* __PRINTF_FMT_H__ */
