/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * Copyright (C) 2009 Dmitry Balakshin <balakshin@jarios.org>
 *
 */

#ifndef __STREAMIO_STREAM_H__
#define __STREAMIO_STREAM_H__

#include <datalib/list.h>

struct streambuf {
  unsigned char *buf;
  size_t limit;
  size_t pos;
  int dirty;
};

struct __stream {
  int fd;
  int eof;
  int error;
  off_t ofs;
  struct streambuf in;
  struct streambuf out;
  list_node_t node;
};

struct __stream* create_stream(void);
void destroy_stream(struct __stream *s);
int fill_stream(struct __stream *s);
int flush_all_streams(void);

#endif  /* __STREAMIO_STREAM_H__ */
