/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * Copyright (C) 2009 Dmitry Balakshin <balakshin@jarios.org>
 *
 */

#include <sys/types.h>
#include <errno.h>
#include <unistd.h>
#include <stdio.h>

#include "__stream.h"

size_t fread(void *ptr, size_t size, size_t nitems, FILE *stream)
{
  int i, j;
  unsigned char *buf;

  if ((ptr == NULL) || (stream == NULL)) {
    errno = EINVAL;
    return 0;
  }
  if ((size == 0) || (nitems == 0))
    return 0;

  buf = ptr;
  for (i = 0; i < nitems; i++)
    for (j = 0; j < size; j++) {
      *buf++ = (unsigned char)fgetc(stream);
      if (feof(stream) || ferror(stream))
        break;
    }

  return i;
}
