/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * Copyright (C) 2009 Dmitry Balakshin <balakshin@jarios.org>
 *
 */

#include <sys/types.h>
#include <errno.h>
#include <unistd.h>
#include <stdio.h>

#include "__stream.h"

int fseek(FILE *stream, long offset, int whence)
{
  off_t ofs;

  if (stream == NULL) {
    errno = EBADF;
    return -1;
  }

  if (fflush(stream) == EOF)
    return -1;

  ofs = lseek(stream->fd, offset, whence);
  if (ofs == (off_t)-1)
    return -1;
  stream->ofs = ofs;
  return fill_stream(stream);
}

int fseeko(FILE *stream, off_t offset, int whence)
{
  off_t ofs;

  if (stream == NULL) {
    errno = EBADF;
    return -1;
  }

  if (fflush(stream) == EOF)
    return -1;

  ofs = lseek(stream->fd, offset, whence);
  if (ofs == (off_t)-1)
    return -1;

  stream->ofs = ofs;
  return 0;
}
