/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 MadTirra <madtirra@jarios.org>
 * (c) Copyright 2008 Dmitry Gromada <gromada@jarios.org>
 *
 * LibOS:
 * lib/routine.c: initialization functions
 *
 */

#include <sys/types.h>
#include <sys/ptd.h>
#include <arch/ptd.h>
#include <time.h>
#include <stdlib.h>
#include <unistd.h>
#include <wchar.h>
#include <errno.h>

int __connect_to_vfs(void);
int __getenviron(void);
#include "../ipc/__lowlevel.h"

/*
 * This function called first 
 * after Jari OS jumped to binary
 */
void __setup(void)
{
  /* init vfs ops */
  __connect_to_vfs();
  /* get environment variables */
  __getenviron();

  /* explicitely reset errno to prevent program from going insane. */
  errno=0;
}
