/*
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Copyright (C) 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * Copyright (C) 2009 Dmitry Balakshin <balakshin@gmail.com>
 *
 * LibOS:
 * lib/time.c: Get time from kenrel/service
 *
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/time.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/swks.h>

/* FIXME: due to current implementation of libchardev we have to open device
 *        only once and never close it.
 */

static int rtc = -1;

time_t time(time_t *tloc)
{
  // int r;
  //char buf[64];
  time_t val;

  swks_t *swks;

/*  if (rtc == -1) {
    rtc = open("/dev/rtc", O_RDONLY);
    if (rtc < 0) {
      return (time_t)-1;
    }
  }

  memset(buf, 0, sizeof(buf));

  r = read(rtc, buf, sizeof(buf));

  close(rtc);

  if (r < 0) {
    errno = -r;
    return (time_t)-2;
  }

  val = (time_t)strtoul(buf, NULL, 10);

  if (tloc != NULL)
  *tloc = val;*/

  swks = get_swks();

  val = swks->system_clock_ticks;
  return val;
}

int settime(time_t tloc)
{
  int r;
  char buf[64];

  if (rtc == -1) {
    rtc = open("/dev/rtc", O_WRONLY);
    if (r < 0) {
      return -1;
    }
  }

  memset(buf, 0, sizeof(buf));
  snprintf(buf, sizeof(buf), "%lu", tloc);

  r = write(rtc, buf, strlen(buf) + 1);
  close(rtc);
  if (r < 0) {
    errno = -r;
    return -1;
  }

  return 0;
}

int gettimeofday(struct timeval *tp, void *tzp)
{
  if (tp == NULL) {
    errno = EINVAL;
    return 0;
  }

  tp->tv_sec = time(NULL);
  tp->tv_usec = 0;

  return 0;
}
