/* This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * Copyright (C) 2009 Dmitry Balakshin <balakshin@jarios.org>
 *
 * LibC:
 * general/libc/unicode/wmemxxx.c
 */

#include <sys/types.h>
#include <errno.h>
#include <string.h>
#include <wchar.h>

wchar_t* wmemcpy(wchar_t *ws1, const wchar_t *ws2, size_t n)
{
  return memcpy(ws1, ws2, n * sizeof(wchar_t));
}

wchar_t* wmemset(wchar_t *ws, wchar_t wc, size_t n)
{
  size_t i;

  if (ws == NULL) {
    errno = EINVAL;
    return NULL;
  }

  for (i = 0; i < n; i++)
    ws[i] = wc;

  return ws;
}
