# Makefile.mk (libsys)
# System related stuff: interrupts, IO ports and so on ...
# Originally written by MadTirra <madtirra@jarios.org>
# (c) Jari OS core development team 2005-2008
#

-include ../../config

ifeq ($(ARCH),amd64)
LIBSYS_OBJS = general/libsys/mach/amd64/ioport.o general/libsys/mach/amd64/irq.o
endif

LIBSYS_OBJS += general/libsys/ioports.o general/libsys/ievent.o general/libsys/irq.o \
               general/libsys/blkdev.o general/libsys/dma.o general/libsys/service.o

CLEAN_OBJS += $(LIBSYS_OBJS)

BUILD_LIBS += libsys.a

BUILD_SO += libsys.so

libsys.a: $(BUILD_DEPS) $(LIBSYS_OBJS)
	$(Q)$(ECHO) "[AR] libsys.a"
	$(Q)$(AR) rc libsys.a $(LIBSYS_OBJS)

libsys.so: $(BUILD_DEPS) $(LIBSYS_OBJS)
	$(Q)$(ECHO) "[LD] libsys.so"
	$(Q)$(LD) -shared -L. $(LIBSYS_OBJS) -lc -nostdlib -o $@
