/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * (c) Copyright 2006,2007,2008,2009 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2009 Dmitry Gromada <gromada@jarios.org>
 *
 * Block device control implementation
 */

#include <sys/blkdev.h>
#include <errno.h>
#include <sys/ioctl.h>

#define BLKIOC_GET_TRACE_EVENTS _IOWRARB(GENSTOR_CTLS, CTL_GET_TRACE_EVENTS, \
                                         struct key_desc)

struct key_desc {
  uint64_t key;
  skey_type_t key_type;
};

int get_blkdev_trace_events(int fd, uint64_t key, skey_type_t key_type,
                            void *buf, size_t buf_size)
{
  struct key_desc kd = {key, key_type};
  int ret;

  if ((buf_size < 0) || (buf_size < sizeof(trace_entry_data_t)))
    return -EINVAL;

  ret = ioctl(fd, BLKIOC_GET_TRACE_EVENTS, buf_size, &kd, buf);
  if (ret)
    ret = -errno;

  return ret;
}
