/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 MadTirra <madtirra@jarios.org>
 *
 * LibOS:
 * lib/ioports.c: IO ports related functions
 *
 */

#include <sys/types.h>
#include <sys/syscall.h>
#include <errno.h>

/* TODO: write in,out implementation, add comments */

/* allocate ports from sport to sport+amount*/
status_t alloc_ioport_range(ulong_t sport,ulong_t amount)
{
  return __syscall2(SC_ALLOCATE_IOPORTS,sport,amount);
}

/* the same just freed */
status_t free_ioport_range(ulong_t sport,ulong_t amount)
{
  return __syscall2(SC_FREE_IOPORTS,sport,amount);
}

