/*
 * This library is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation; either version 2.1 of 
 * the License.
 *
 * This library is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public 
 * License along with this library; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
 *
 * (c) Copyright 2006,2007,2008 Jari OS Core Team <http://jarios.org>
 * (c) Copyright 2008 MadTirra <madtirra@jarios.org>
 * (c) Copyright 2008 Paul Graphov <graphov@jarios.org>
 *
 * LibOS:
 * platform/amd64/ioport.c: standart C printfs
 *
 */

#include <sys/types.h>

/* read byte value from io port */
inline uint8_t inb(uint16_t port)
{
  uint8_t vl;

  __asm__ volatile ("inb %1, %0\n" : "=a" (vl) : "d" (port));

  return vl;
}

/* put byte value to io port */
inline void outb(uint16_t port,uint8_t vl)
{
  __asm__ volatile ("outb %0, %1\n" : : "a" (vl), "Nd" (port));
}

/* read 16 bit value from io port */
inline uint16_t inw(uint16_t port)
{
  uint16_t vl;

  __asm__ volatile ("inw %1, %0\n" : "=a" (vl) : "d" (port));

  return vl;
}

/* put 16 bit value to io port */
inline void outw(uint16_t port,uint16_t vl)
{
  __asm__ volatile ("outw %0, %1\n" : : "a" (vl), "Nd" (port));
}

/* read 32 bit value from io port */
inline uint32_t inl(uint16_t port)
{
  uint32_t vl;

  __asm__ volatile ("inl %1, %0\n" : "=a" (vl) : "d" (port));

  return vl;
}

/* put 32 bit value to io port */
inline void outl(uint16_t port,uint32_t vl)
{
  __asm__ volatile ("outl %0, %1\n" : : "a" (vl), "Nd" (port));
}
